      program dnv3e
      integer jy(5),jn(5)
      integer iw(40000)
      real rw(40000)
      real u(1400000), v(13e5), w(13e5)
      real x(13e5)
      real cft(13e5), cfi(13e5), cs(13e5)
      equivalence(cfi,cs)
      real apu(5)
      real tarray(2)
      character*50 matrix,rhs
      character*56 sofm
      character*80 bgmodel
      logical kscale,twod
      common/nrs/nif,depsilon
10    format(a,$ )
      write(6,*) "program dnv3e:"
      write(6,10) 'Give name of matrix: '
      read(5,'(a)') matrix
      write(6,*) matrix
      write(6,10) 'give name of right hand side vector q:'
      read(5,'(a)') rhs
      write(6,*) rhs
      write(6,10) "give damp factor:"
      read(5,*) depsilon
      if(.not.(depsilon .gt. 0.))goto 23000
      write(6,*) " damp factor = ",depsilon
      goto 23001
23000 continue
      write(6,*) " damping off"
23001 continue
      open(9,file='columnfactors0',status='old')
      rewind 9
      read(9,*) ncolc0, nsq, njy, (apu(j),j=1,njy), jntr, apu5, 
&     colmaxapu, scepsilon
      close(9)
      write(6,*) "done with columnfactors0"
      nptot = njy*nsq+jntr
      inquire(file="profile.info",exist=twod)
      if(.not.(twod))goto 23002
      open(9,file="profile.info",status="old")
      rewind 9
      read(9,'(a80)') bgmodel
      read(9,*) x1,x2,x3,x4,x5,x6,i7,i8,x9,nsrc,apu6
      close(9)
      write(6,*) "done with profile.info"
      goto 23003
23002 continue
      nsrc = 0
23003 continue
      nptot = nptot + nsrc
      if(.not.(nptot .ne. ncolc0))goto 23004
      write(6,*) 'ERROR in column counting for ext. scaling'
      write(6,*) nptot, ncolc0
      stop
23004 continue
      top = 1. + scepsilon
      xepsilon = colmaxapu*scepsilon
      write(6,10) 
&     "column scaling (with quasi-inverse of columnsums) on (T) or off (
&     F)?:"
      read(5,*) kscale
      if(.not.(kscale))goto 23006
      write(6,*) ' int. column scaling on'
      write(6,*) ' column scaling damp-factor = ',scepsilon
      open(1,file='columnsums',status='old')
      rewind 1
      read(1,*) ncolc
      if(.not.(ncolc .ne. ncolc0))goto 23008
      write(6,*) 
&     'ERROR: incompatible # of columns in ext. and int. scaling'
      stop
23008 continue
      read(1,*) (cs(i),i=1,ncolc)
      close(1)
      write(6,*) 'file columnsums has been read'
      do 23010 j=1,njy 
      do 23012 i = (j-1)*nsq + 1, j*nsq 
      bot = apu(j)*cs(i) + xepsilon
      cfi(i) = top/bot
23012 continue
23010 continue
      do 23014 i = njy*nsq + 1, njy*nsq + jntr 
      bot = apu5*cs(i) + xepsilon
      cfi(i) = top/bot
23014 continue
      do 23016 i = njy*nsq + jntr + 1, njy*nsq + jntr + nsrc 
      bot = apu6*cs(i) + xepsilon
      cfi(i) = top/bot
23016 continue
      goto 23007
23006 continue
      write(6,*) " int. column scaling off"
      do 23018 i=1,ncolc0 
      cfi(i) = 1.
23018 continue
23007 continue
      do 23020 j=1,njy 
      do 23022 i = (j-1)*nsq + 1, j*nsq 
      cft(i) = cfi(i)*apu(j)
23022 continue
23020 continue
      do 23024 i = njy*nsq + 1, njy*nsq + jntr 
      cft(i) = cfi(i)*apu5
23024 continue
      do 23026 i = njy*nsq + jntr + 1, njy*nsq + jntr + nsrc 
      cft(i) = cfi(i)*apu6
23026 continue
      sofm = 'sizeof'//matrix
      write(6,*) sofm
      open(2,file=sofm,status='old')
      rewind 2
      read(2,*) mrow,ncol,nmmx,nif
      close(2)
      if(.not.(mrow .gt. 110000))goto 23028
      stop 'increase maxic (# of rows) in worklims'
23028 continue
      if(.not.(mrow .eq. 0))goto 23030
      stop 'mrow is null'
23030 continue
      if(.not.(ncol .gt. 13e5))goto 23032
      stop 'increase nminv (# of columns) in worklims'
23032 continue
      if(.not.(ncol .eq. 0))goto 23034
      stop 'mrow is null'
23034 continue
      if(.not.(nmmx .gt. 40000))goto 23036
      stop 'increase nonzr (# of non-zeroes) in workdefs'
23036 continue
      if(.not.(kscale .and. ncolc .ne. ncol))goto 23038
      stop 'columnfactors not right nr of columns'
23038 continue
      m = mrow + ncol
      n = ncol
      lenrw = nmmx
      leniw = nmmx
      write(6,*) 'read:'
      write(6,*) 'nr of rows:',m
      write(6,*) 'nr of real rows:',mrow
      write(6,*) 'nr of colums:',n
      write(6,*) 'max nr of non-zeroes per row:',leniw
      write(6,*) 'number of paths involved:',nif
      open(2,file=rhs)
      rewind 2
      do 23040 k=1,mrow 
      read(2,*,end=100) u(k)
23040 continue
      close(2)
      do 23042 k=mrow+1,m 
      u(k) = 0.
23042 continue
      write(6,*) "give max nr of iterations:"
      read(5,*) itmax
      write(6,*) itmax
      if(.not.(itmax .lt. 1 .or. itmax .gt. 1000))goto 23044
      write(6,*) "ridiculous number"
      stop
23044 continue
      cpu = etime(tarray)
      write(6,*) "Entering pstomd..."
      call pstomd(m,n,x,u,v,w,itmax,leniw,lenrw,iw,rw,depsilon,cft,cfi,
&     matrix)
      cpu = etime(tarray) - cpu
      write(6,*) ''
      write(6,*) "pstomd took ",cpu," s = ",cpu/60," minutes"
      do 23046 i = 1,n 
      x(i) = cft(i)*x(i)
23046 continue
      write(6,*) 
&     'solution rescaled with internal and external columnfactors'
      write(6,*) 'solution is thus no longer dimensionless'
      do 23048 j=1,njy 
      smn = 999
      smx = -999.
      sav = 0.
      do 23050 i = (j-1)*nsq + 1, j*nsq 
      sav = sav + x(i)
      smx = max(smx,x(i))
      smn = min(smn,x(i))
23050 continue
      sav = sav/nsq
      write(6,*) 'min, avg and max of apu ',apu(j),' solution: ',smn,
&     sav,smx
23048 continue
      if(.not.(jntr .gt. 0))goto 23052
      smn = 999
      smx = -999.
      sav = 0.
      do 23054 i = njy*nsq + 1, njy*nsq + jntr 
      sav = sav + x(i)
      smx = max(smx,x(i))
      smn = min(smn,x(i))
23054 continue
      sav = sav/jntr
      write(6,*) 'min, avg and max of apu ',apu5,' solution: ',smn,sav,
&     smx
23052 continue
      open(2,file='solution')
      rewind 2
      write(2,*) n
      write(2,*) (x(i), i=1,n)
      close(2)
      write(6,*) "solution written to file 'solution'"
      write(6,*) ''
      write(6,*) 'dnv3e finished'
      stop
100   write(6,*) 'premature end to file ',rhs
      write(6,*) 'k= ',k,' m= ',m
      end
