      program makeanieu
      character*7 fname
      dimension solution(13e5)
      dimension jy(5),jn(5),apu(5)
      dimension ia(30000),fa(30000)
      dimension wc(10)
      dimension xnode(13e5),ynode(13e5)
      logical out
      real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
      data itypes/2/
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      do 23000 i=1,13e5 
      solution(i) = 0.
23000 continue
      call setgrid(ddd,avdd,distmax)
      open(1,file='model.shell',status='old')
      rewind(1)
      read(1,*) ntr,nt,imx,dmxd,cold,rmoho
      write(6,*) nsq,' nodes in 3D model'
      close(1)
      call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
      n=0
      j=1
      do 23002 while (jy(j) .lt. itypes) 
      n = n+1
      j = j+1
23002 continue
      if(.not.(jy(j) .ne. itypes))goto 23004
      write(6,*) 'Sorry, your data do not include S-velocities,'
      write(6,*) 'I will not compute a synthetic S-velocity model.'
      stop
23004 continue
      apus=apu(j)
      ioff=n
      noff = ioff*nsq
      ncol = njy*nsq + jmoho*ntr
      write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol
      write(6,*) "Give depth (in km) to top of anisotropic layer:"
      read(5,*) rup
      write(6,*) "Give depth (in km) to bottom of anisotropic layer:"
      read(5,*) rdown
      rup = 6371. - rup
      rdown = 6371. - rdown
      write(6,*) "Give equivalent S-velocity perturbation (in m/s):"
      read(5,*) dbeta
      index = noff
      z = zmax + dz
      do 23006 iz = 1, nz 
      z = z - dz
      y = ymax + dy
      do 23008 iy = 1, ny 
      y = y - dy
      x = xmin - dx
      do 23010 ix = 1, nx 
      x = x + dx
      index = index+1
      call rtfxyz(1,t,f,r,x,y,z)
      call rotate(1,t,f,tt,ft)
      t = tt/1.74533e-2
      f = ft/1.74533e-2
      if(.not.(r .le. rup .and. r .ge. rdown))goto 23012
      solution(index) = dbeta
23012 continue
23010 continue
23008 continue
23006 continue
      smin = 0
      smax = 0
      do 23014 i=1,ncol 
      smax = max(solution(i),smax)
      smin = min(solution(i),smin)
23014 continue
      write(6,*) 'min,max solution:',smin,smax
      fname = "syn.ani"
      open(1,file=fname,status='new')
      rewind 1
      write(1,*) ncol
      write(1,*) (solution(i),i=1,ncol)
      close(1)
      end
