program makerhs
include workdefs
include worklims
dimension yrhs(maxic),x(nminv)
dimension iw(nonzr),rw(nonzr)
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
character*50 matrix,rhs,sol
character*56 sofm
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

#call setgrid(ddd,avdd,distmax)

do i=1,maxic {
   yrhs(i) = 0.
}
do i=1,nminv {
   x(i) = 0.
}

write(6,*) 'give name of synthetic solution:'
read(5,'(a)') sol
open(1,file=sol,status='old')
rewind 1
read(1,*) nsol
read(1,*) (x(i),i=1,nsol)
close(1)

call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
#do j= 1,njy {
#   ioff = (j-1)*nsq
#   do i= ioff + 1, ioff + nsq {
#      x(i) = x(i)/apu(j)
#   }
#}
#if (jmoho == 1) {
#   open(1,file='model.shell',status='old')
#   rewind 1
#   read(1,*) ntr
#   close(1)
#   ioff = njy*nsq
#   do i = ioff +1, ioff + ntr {
#      x(i) = x(i)/apu5
#   }
#}

write(6,*) 'give name of matrix:'
read(5,'(a)') matrix
open(3,file=matrix,form='unformatted')
rewind 3

sofm = 'sizeof'//matrix
open(1,file=sofm,status='old')
rewind 1
read(1,*) mrow,ncol,nmmx,nif
close(1)

write(6,*) 'give name of output right hand side:'
read(5,'(a)') rhs

#open(7,file='allnpars')
#rewind 7

ic = 0
do ifs=1,nif {
   read(3,end=200) ifsin, npar, nz
#   write(7,*) ifsin,npar
   if (ifsin.ne.ifs) write(6,*) 'error: ',ifs,' ! = ',ifsin 
   read(3,end=200) (iw(i),i=1,nz)
   do k = ic+1,ic+npar {
      read(3,end=200) (rw(i),i=1,nz)
      yrhs(k) = 0.
      do i=1,nz { yrhs(k) = yrhs(k) + rw(i)*x(iw(i)) }
   } 
   ic = ic + npar
}

write(6,*) 'nr. of constraints:',ic
if (ic != mrow) write(6,*) 'ERROR'

open(1,file=rhs,status='new')
rewind 1
do i=1,mrow {
   write(1,*) yrhs(i)
}
close(1)

goto 300
200 write(6,*) 'premature end to file matrix'
write(6,*) 'nif= ',nif,' ic= ',ic
300 end
