      subroutine pstomd(m,n,x,u,v,w,itmax,leniw,lenrw,iw,rw,depsilon,
&     cft,cfi,matrix)
      character*80 tomoint
      integer iw(leniw)
      real rw(lenrw)
      dimension x(n),u(m),v(n),w(n)
      dimension xprev(13e5),dx(13e5),dxprev(13e5)
      dimension itw(14)
      real cfi(n), cft(n)
      character*50 matrix
      data itw/1,2,3,4,5,7,9,12,15,18,21,25,30,40/
20    format(a4,1x,a10,1x,a10,1x,a2,1x,a10,1x,a7,1x,a7,1x,a10,1x,a10,1x,
&     a1)
30    format(i4,1x,f10.4,1x,f10.7,1x,a2,1x,f10.4,1x,f7.3,1x,f7.3,1x,f10.
&     4,1x,f10.4,3x,f5.3)
      write(6,*) 'give path/filename for enormous tomo.int:'
      read(5,'(a)') tomoint
      write(6,*) ' writing to:',tomoint
      write(6,*) ''
      open (9,file=tomoint,form='unformatted')
      write(9) n
      dxnorm = 0.
      xnorm = 0.
      do 23000 i=1,n 
      dx(i)=0
      x(i)=0
      v(i)=0
23000 continue
      call normlz(m,u,beta)
      b1=beta
      call dpror(2,m,n,v,u,leniw,lenrw,iw,rw,cft,cfi,matrix)
      call normlz(n,v,alfa)
      rhobar=alfa
      phibar=beta
      do 23002 i=1,n 
      w(i)=v(i) 
23002 continue
      write(6,20) 'iter ','phibar ','r ','--','||dx|| ','cosdd ',
&     'cosd ','||Ax-b|| ','||x|| ','r'
      write(6,30) 0,beta,1.,'--',0.,0.,0.,beta, 0.,1.
      do 23004 iter =1,itmax 
      a= - alfa
      do 23006 i=1,m 
      u(i)=a*u(i) 
23006 continue
      call dpror(1,m,n,v,u,leniw,lenrw,iw,rw,cft,cfi,matrix)
      call normlz(m,u,beta)
      b= - beta
      do 23008 i=1,n 
      v(i)=b*v(i) 
23008 continue
      call dpror(2,m,n,v,u,leniw,lenrw,iw,rw,cft,cfi,matrix)
      call normlz(n,v,alfa)
      rho=sqrt(rhobar*rhobar+beta*beta)
      c=rhobar/rho
      s=beta/rho
      teta=s*alfa
      rhobar= - c*alfa
      phi=c*phibar
      phibar=s*phibar
      t1=phi/rho
      t2= - teta/rho
      dxprevnorm = dxnorm
      xprevnorm = xnorm
      do 23010 i=1,n 
      x(i)=t1*w(i)+x(i)
      w(i)=t2*w(i)+v(i)
23010 continue
      r=phibar/b1
      call getnorm(n,x,cfi,xnormsq)
      xnorm = sqrt(xnormsq)
      axminbsq = phibar*phibar - depsilon*depsilon*xnormsq
      sqaxminbsq = sqrt(axminbsq)
      ddxinp = 0.
      dxinp = 0.
      do 23012 i=1,n 
      realx = cfi(i)*x(i)
      dx(i) = realx - xprev(i)
      ddxinp = ddxinp + dx(i)*dxprev(i)
      dxinp = dxinp + dx(i)*xprev(i)
      xprev(i) = realx
      dxprev(i) = dx(i)
23012 continue
      call getdnorm(n,dx,addxnormsq)
      dxnorm = sqrt(addxnormsq)
      if(.not.(dxprevnorm .gt. 0.))goto 23014
      ddxinp = ddxinp/dxprevnorm
      goto 23015
23014 continue
      ddxinp = 0 
23015 continue
      if(.not.(xprevnorm .gt. 0.))goto 23016
      dxinp = dxinp/xprevnorm
      goto 23017
23016 continue
      dxinp = 0 
23017 continue
      if(.not.(dxnorm .gt. 0.))goto 23018
      ddxinp = ddxinp/dxnorm
      dxinp = dxinp/dxnorm
      goto 23019
23018 continue
      ddxinp = 0
      dxinp = 0 
23019 continue
      write(6,30) iter,phibar,r,'--',dxnorm,ddxinp,dxinp,sqaxminbsq,
&     xnorm,sqaxminbsq/b1
      do 23020 i = 1,14 
      if(.not.(iter .eq. itw(i)))goto 23022
      write(9) iter,(xprev(j),j=1,n),v,alfa,beta,phibar,r
23022 continue
23020 continue
23004 continue
      return
      end
      subroutine normlz(n,x,s)
      dimension x(n)
      s=0.
      do 23024 i=1,n 
      s=s+x(i)**2 
23024 continue
      s=sqrt(s)
      ss=1./s
      do 23026 i=1,n 
      x(i)=x(i)*ss 
23026 continue
      return
      end
      subroutine getnorm(n,x,c,s)
      dimension x(n),c(n)
      s=0.
      do 23028 i=1,n 
      s=s+(c(i)*x(i))**2 
23028 continue
      return
      end
      subroutine getdnorm(n,x,s)
      dimension x(n)
      s=0.
      do 23030 i=1,n 
      s=s+x(i)*x(i) 
23030 continue
      return
      end
