subroutine setgrid(ddd,avdd,distmax)
include defines
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

# define new northpole through its latitude and longitude:
# ola, olo. Define the new 0-meridian through its azimuth
# (relative to the Northpole) at the new northpole.
# (the x-axis points through the point where the 0-meridian
# and the equator cross, the y-axis points through the point
# where the 90 degr. meridian crosses the equator)

open(2,file = 'model.cube',status='old')
rewind 2
read(2,*) ola,olo,oazi,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
close(2)
nxy = nx*ny
nsq = nxy*nz
call checkmodel(ddd,avdd,distmax)
write(6,*) ola,olo,oazi,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

# North-America: ola = 40.  olo = -100.  oazi = 90.
# Europe: ola = 45.  olo = 33.  oazi = 90.
# Equator: ola = 0.  olo = 0.  oazi = 90.

# convert to radians:
ola = ola*p
olo = olo*p
oazi = oazi*p

return
end
