      dimension pq(300),iq(300)
      dimension pql(8),iql(8)
      dimension pt(300),it(300)
      dimension ptl(3),itl(3)
      dimension sol(13e5)
      dimension cols(13e5)
      dimension asol(500,500)
      dimension a3d(13e5),c3d(13e5)
      dimension asav(300)
      dimension br(300)
      dimension by(300,4)
      character*1 na3d(13e5),nc3d(13e5)
      dimension cs(500,500)
      character*15 txt(5)
      character*50 slicename, argv, mohoname, toponame
      character*52 colname
      character*2 aflg
      character*4 bname
      dimension jy(5)
      dimension tt(610000),pp(610000)
      dimension wc(4)
      logical out,black,leps,exag,back,relat
      data txt/'P-wave velocity','S-wave velocity','density',
&     'Shear Quality','Moho depth'/
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      write(6,*) 'program sns:'
10    format(a,$ )
20    format('#',1x,a16,1x,6f9.2)
30    format(i4,a17,5f8.2)
40    format(2f9.2)
      inquire(file='epsilon',exist=leps)
      if(.not.(leps))goto 23000
      open(1,file='epsilon')
      read(1,*) cseps
      close(1)
      goto 23001
23000 continue
      cseps = 0.0001
23001 continue
      inquire(file='topoexag',exist=exag)
      if(.not.(exag))goto 23002
      open(1,file='topoexag')
      read(1,*) topoexag
      close(1)
      goto 23003
23002 continue
      topoexag = 10.
23003 continue
      iar = iargc()
      relat=.false.
      if(.not.(iar .eq. 1))goto 23004
      call getarg(iar,argv)
      black = .false.
      back = .false.
      goto 23005
23004 continue
      if(.not.(iar .gt. 1))goto 23006
      do 23008 ia = 1,iar-1 
      call getarg(ia,aflg)
      if(.not.(aflg .eq. '-w'))goto 23010
      inquire(file='columnsums',exist=black)
      if(.not.(.not. black))goto 23012
      write(6,*) 'error: file columnsums does not exist'
23012 continue
      write(6,*) 'epsilon (max colsum for blackout) = ',cseps
      goto 23011
23010 continue
      if(.not.(aflg .eq. '-a'))goto 23014
      inquire(file='backgroundmodel',exist=back)
      if(.not.(.not. back))goto 23016
      write(6,*) 'error: file backgroundmodel does not exist'
23016 continue
      goto 23015
23014 continue
      if(.not.(aflg .eq. '-r'))goto 23018
      inquire(file='backgroundmodel',exist=back)
      if(.not.(.not. back))goto 23020
      write(6,*) 'error: file backgroundmodel does not exist'
23020 continue
      relat = .true.
23018 continue
23015 continue
23011 continue
23008 continue
      call getarg(iar,argv)
      goto 23007
23006 continue
      write(6,*) 'Usage: sns [-w] [-a/-r] modelname'
      write(6,*) ''
      stop
23007 continue
23005 continue
      if(.not.(black))goto 23022
      write(6,*) 'file columnsums used to white-out unsampled areas'
23022 continue
      if(.not.(back))goto 23024
      open(1,file='backgroundmodel',status='old')
      read(1,*) bname
      write(6,*) 'backgroundmodel used = ',bname
      read(1,*)
      read(1,*) nba, nbi, nbo
      nbc = nbi + nbo
      do 23026 i = 1,nbc 
      read(1,*) 
23026 continue
      nba = nba - nbc
      do 23028 i = 1,nba 
      read(1,*) br(i),by(i,3),by(i,1),by(i,2),dum,by(i,4)
      br(i) = 0.001*br(i)
      by(i,1) = 0.001*by(i,1)
      by(i,2) = 0.001*by(i,2)
      by(i,3) = 0.001*by(i,3)
      by(i,4) = 0.001*by(i,4)
23028 continue
      close(1)
23024 continue
      do 23030 i = 1,500 
      do 23032 j = 1,500 
      asol(i,j) = 0.
      cs(i,j) = 0.
23032 continue
23030 continue
      open(1,file='model.cube',status='old')
      rewind 1
      read(1,*) ola,olo,oazi,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,
&     dy,dx
      close(1)
      write(6,*) 'read model.cube'
      ola = ola*1.74533e-2
      olo = olo*1.74533e-2
      oazi = oazi*1.74533e-2
      nxy = nx*ny
      nsq = nxy*nz
      open(1,file='smooth',status='old')
      rewind 1
      read(1,*) stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
      close(1)
      write(6,*) 'read smooth'
      write(6,*) 'stk = ',stk,' km'
      open(1,file='parcom',status='old')
      rewind 1
      read(1,*) njy
      read(1,*) (jy(j),j=1,njy)
      close(1)
      write(6,*) 'read parcom'
      do 23034 j=1,njy 
      if(.not.(jy(j).eq.5))goto 23036
      jmoho = 1
      goto 23037
23036 continue
      jmoho = 0
23037 continue
23034 continue
      if(.not.(jmoho.eq.1))goto 23038
      open(1,file='model.shell',status='old')
      rewind 1
      read(1,*) ntr,nt,imx,dmxd,cold,rmoho
      read(1,*) (tt(k),k=1,ntr)
      read(1,*) (pp(k),k=1,ntr)
      close(1)
      write(6,*) 'read model.shell'
      col = cold*1.74533e-2
      dmx = dmxd*1.74533e-2
23038 continue
      open(1,file=argv,status='old')
      rewind 1
      read(1,*) mnnn
      read(1,*) (sol(i),i=1,mnnn)
      close(1)
      write(6,*) 'read ',argv
      if(.not.(black))goto 23040
      open(1,file='columnsums',status='old')
      rewind 1
      read(1,*) mncl
      if(.not.(mncl .ne. mnnn))goto 23042
      write(6,*) 
&     'error: # of elements from columnsums and model not compatible'
      stop
23042 continue
      read(1,*) (cols(i),i=1,mncl)
      close(1)
      write(6,*) 'read columnsums'
23040 continue
      jchoice = 0
      iopt = 0
      write(6,*) 'solution contains:'
      do 23044 j=1,njy 
      write(6,*) j,' ',txt(jy(j)) 
23044 continue
      do 23046 while (jchoice .lt. 1 .or. jchoice .gt. 5) 
      write(6,10) 'which parameter (give number):'
      read(5,*) jchoice 
23046 continue
      ioff = (jchoice-1)*nsq
      ioffm = (njy-1)*nsq
      kb = jy(jchoice)
      if(.not.(jy(jchoice) .eq. 5))goto 23048
      rshell = rmoho
      iopt = -3
      write(6,*) 'slice type, option -3'
23048 continue
      if(.not.(iopt .eq. 0))goto 23050
      write(6,*) 'select slice type, options:'
      write(6,*) 
&     '1) latitude, longitude, azimuth, delta, depth-extent'
      write(6,*) 
&     '2) latitude1, longitude1, latitude2, longitude2, depth-extent'
      write(6,*) '3) depth = constant, latmin, latmax, lonmin, lonmax'
      write(6,*) '4) brick as is (in cartesian grid)'
      write(6,*) '5) brick in lon, lat, r'
      write(6,*) 'all in km or degrees'
      write(6,*) '6) 1-D model'
      do 23052 while (iopt .lt. 1 .or. iopt .gt. 6) 
      write(6,10) 'selected option: '
      read(5,*) iopt 
23052 continue
23050 continue
      if(.not.(iopt .eq. 6 .and. back .eq. .false.))goto 23054
      write(6,*) 'Option 6 only possible with "-a" or "-r" flag'
      stop
23054 continue
      write(6,10) "give filename for output: "
      read(5,'(a)') slicename
      write(6,*) slicename
      colname = 'cl'//slicename
      mohoname = 'mh'//slicename
      toponame = 'tp'//slicename
      if(.not.(iopt .eq. 1))goto 23056
      open(2,file=slicename)
      rewind 2
      if(.not.(black))goto 23058
      write(6,*) colname
      open(4,file=colname)
      rewind 4
23058 continue
      write(6,*) 
&     'give latitude1, longitude1, azimuth, delta, depth-extent: '
      read(5,*) xlat1,xlon1,azimuth,delta,depth
      write(6,10) 'Give ddelta and ddepth:'
      read(5,*) da,db
      xlat1 = xlat1*1.74533e-2
      xlon1 = xlon1*1.74533e-2
      delta = delta*1.74533e-2
      azimuth = azimuth*1.74533e-2
      call fiteta(fi2,teta2,xlon1,xlat1,azimuth,delta)
      xlon2 = fi2
      xlat2 = teta2
      write(6,*) 'To:',xlat2/1.74533e-2,xlon2/1.74533e-2
      call rotate(0,xlat1,xlon1,tetaout,fiout)
      xlat1 = tetaout
      xlon1 = fiout
      call rotate(0,xlat2,xlon2,tetaout,fiout)
      xlat2 = tetaout
      xlon2 = fiout
      call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
      rup = 6371.
      rdown = 6371. - depth
23056 continue
      if(.not.(iopt .eq. 2))goto 23060
      open(2,file=slicename)
      rewind 2
      if(.not.(black))goto 23062
      write(6,*) colname
      open(4,file=colname)
      rewind 4
23062 continue
      write(6,*) 
&     'give latitude1, longitude1, latitude2, longitude2, depth-extent: 
&     '
      read(5,*) xlat1,xlon1,xlat2,xlon2,depth
      write(6,10) 'Give ddelta and ddepth:'
      read(5,*) da,db
      xlat1 = xlat1*1.74533e-2
      xlat2 = xlat2*1.74533e-2
      xlon1 = xlon1*1.74533e-2
      xlon2 = xlon2*1.74533e-2
      call rotate(0,xlat1,xlon1,tetaout,fiout)
      xlat1 = tetaout
      xlon1 = fiout
      call rotate(0,xlat2,xlon2,tetaout,fiout)
      xlat2 = tetaout
      xlon2 = fiout
      call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
      write(6,*) 'distance is ',delta/1.74533e-2,' degrees'
      rup = 6371.
      rdown = 6371. - depth
      iopt = 1
23060 continue
      if(.not.(iopt .eq. 3))goto 23064
      open(2,file=slicename)
      rewind 2
      if(.not.(black))goto 23066
      write(6,*) colname
      open(4,file=colname)
      rewind 4
23066 continue
      write(6,*) 
&     'give depth of layer, latmin, latmax, lonmin, lonmax: '
      read(5,*) rshell,atmin,atmax,onmin,onmax
      write(6,10) 'Give dlat and dlon:'
      read(5,*) db,da
      rshell = 6371. - rshell
23064 continue
      if(.not.(iopt .eq. -3))goto 23068
      open(2,file=slicename)
      rewind 2
      if(.not.(black))goto 23070
      write(6,*) colname
      open(4,file=colname)
      rewind 4
23070 continue
      write(6,*) 'give latmin, latmax, lonmin, lonmax: '
      read(5,*) atmin,atmax,onmin,onmax
      write(6,10) 'Give dlat and dlon:'
      read(5,*) db,da
23068 continue
      if(.not.(iopt .eq. 3 .or. iopt .eq. -3))goto 23072
      atmin = atmin*1.74533e-2
      onmin = onmin*1.74533e-2
      atmax = atmax*1.74533e-2
      onmax = onmax*1.74533e-2
      da = da*1.74533e-2
      db = db*1.74533e-2
      amin = onmin
      amax = onmax
      bmin = atmin
      bmax = atmax
      sc = 1./1.74533e-2
      arange = amax-amin
      brange = bmax-bmin
      na = nint(arange/da) + 1
      nb = nint(brange/db) + 1
      if(.not.(nb .gt. 500 .or. na .gt. 500))goto 23074
      write(6,*) "Dimension of asol exceeded!"
      stop
23074 continue
23072 continue
      if(.not.(iopt .eq. 4 .or. iopt .eq. 5))goto 23076
      open(2,file=slicename)
      rewind 2
      if(.not.(black))goto 23078
      open(4,file=colname)
      rewind 4
23078 continue
23076 continue
      if(.not.(iopt .eq. 5))goto 23080
      write(6,*) 
&     'give depthmin, depthmax, latmin, latmax, lonmin, lonmax: '
      read(5,*) depthmin,depthmax,atmin,atmax,onmin,onmax
      write(6,10) 'Give ddelta and ddepth:'
      read(5,*) da,db
      rup = 6371. - depthmin
      rdown = 6371. - depthmax
      range = rup - rdown
      nr = nint(range/db) + 1
      dr = db
      amin = atmin*1.74533e-2
      amax = atmax*1.74533e-2
      bmin = onmin*1.74533e-2
      bmax = onmax*1.74533e-2
      arange = amax-amin
      brange = bmax-bmin
      ddelta = ddelta/6371.
      na = nint(arange/da) + 1
      nb = nint(brange/da) + 1
      db = da
23080 continue
      if(.not.(iopt .eq. 6))goto 23082
      open(2,file=slicename)
      rewind 2
      write(6,*) 
&     'give latitude1, longitude1, latitude2, longitude2, depth-extent:'
      read(5,*) xlat1,xlon1,xlat2,xlon2,depth
      write(6,10) 'Give ddelta:'
      read(5,*) da
      xlat1 = xlat1*1.74533e-2
      xlat2 = xlat2*1.74533e-2
      xlon1 = xlon1*1.74533e-2
      xlon2 = xlon2*1.74533e-2
      call rotate(0,xlat1,xlon1,tetaout,fiout)
      xlat1 = tetaout
      xlon1 = fiout
      call rotate(0,xlat2,xlon2,tetaout,fiout)
      xlat2 = tetaout
      xlon2 = fiout
      call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
      write(6,*) 'distance is ',delta/1.74533e-2,' degrees'
      rup = 6371.
      rdown = 6371. - depth
23082 continue
      cmax = 0.
      asmax = -1.*100000.
      asmin = 100000.
      if(.not.(iopt .eq. 1))goto 23084
      open(10,file=mohoname)
      rewind 10
      open(11,file=toponame)
      rewind 11
      range = rup - rdown
      dr = db
      nb = nint(range/db) + 1
      da = da*1.74533e-2
      na = nint(delta/da) + 1
      if(.not.(nb .gt. 500 .or. na .gt. 500))goto 23086
      write(6,*) "Dimension of asol exceeded!"
      stop
23086 continue
      print*, "slicing..."
      acoor = 90. + 0.5*delta/1.74533e-2
      dacoor = da/1.74533e-2
      do 23088 i = 1,na 
      do 23090 j = 1,nb 
      as = 0.
      r = (rup - (j-1)*dr)
      call rtfxyz(0,xlat1,xlon1,r,x,y,z)
      call getc(x,y,z,r,xlat1,xlon1,nq,iq,pq,out)
      do 23092 l=1,nq 
      as = as + pq(l)*sol(ioff + iq(l))
23092 continue
      if(.not.(back))goto 23094
      bas = finterp(r,br,by(1,kb),nba)
      if(.not.(relat))goto 23096
      as = 0.1*as/bas
      goto 23097
23096 continue
      as = bas + 0.001*as
23097 continue
23094 continue
      if(.not.(as.gt.asmax))goto 23098
      asmax = as
      elamax = acoor*1.74533e-2
      elomax = r*1.74533e-2
23098 continue
      if(.not.(as.lt.asmin))goto 23100
      asmin = as
      elamin = acoor*1.74533e-2
      elomin = r*1.74533e-2
23100 continue
      if(.not.(black))goto 23102
      cst = 0.
      call getclin(x,y,z,nql,iql,pql,out)
      do 23104 l=1,nql 
      cst = cst + pql(l)*cols(ioff+iql(l))
23104 continue
      if(.not.(cst .lt. cseps))goto 23106
      as = 100000.
      goto 23107
23106 continue
      cmax = max(cmax,cst)
23107 continue
      cs(i,j) = cst
23102 continue
      asol(i,j) = as
      write(2,*) acoor,r+29.,as
      if(.not.(black))goto 23108
      write(4,*) acoor,r+29.,cst
23108 continue
23090 continue
      dmh = 0
      call gett(out,col,xlat1,xlon1,ntr,tt,pp,ni,it,pt)
      do 23110 l=1,ni 
      dmh = dmh + pt(l)*sol(ioffm+it(l))
23110 continue
      dmh = rmoho + 29. - 0.001*dmh
      call rotate(1,xlat1,xlon1,rlat,rlon)
      drlat = rlat/1.74533e-2
      drlon = rlon/1.74533e-2
      topo = etopo5web(drlat,drlon)
      topo = 6371. + 29 + topoexag*0.001*topo
      acr = acoor
      if(.not.(i.eq.1))goto 23112
      acr = 0.9999*acoor
23112 continue
      if(.not.(i.eq.na))goto 23114
      acr = 1.0001*acoor
23114 continue
      write(11,40) acr, topo
      if(.not.(black))goto 23116
      cstm = 0.
      call gettlin(out,col,dmx,xlat1,xlon1,ntr,tt,pp,nil,itl,ptl)
      do 23118 l=1,nil 
      cstm = cstm + ptl(l)*cols(ioffm+itl(l))
23118 continue
      write(10,40) acr, dmh
      goto 23117
23116 continue
      write(10,40) acr, dmh
23117 continue
      call nextcoor(xlat1,xlon1,da,azimuth,xlat2,xlon2)
      acoor = acoor - dacoor
23088 continue
      write(6,*) 'written ',slicename
      write(6,*) 'nr of nodes: ',na,nb
      write(6,*) 'spacing (degrees,km): ',dacoor,dr
      open(8,file='spacing')
      write(8,'(f9.5,"/",f9.5)') dacoor,dr
      close(8)
      close(10)
      close(11)
      write(6,*) 'written ',mohoname
      write(6,*) 'written ',toponame
      call mkclrpt(asmin,asmax)
23084 continue
      if(.not.(iopt .eq. 6))goto 23120
      j = 1
      do 23122 while (br(nba+1-j).gt.rdown) 
      j = j + 1
23122 continue
      nb = j
      da = da*1.74533e-2
      na = nint(delta/da) + 1
      if(.not.(na .gt. 500))goto 23124
      write(6,*) "Dimension of asol exceeded!"
      stop
23124 continue
      print*, "slicing..."
      acoor = 90. + 0.5*delta/1.74533e-2
      dacoor = da/1.74533e-2
      do 23126 i = 1,na 
      do 23128 j = 1,nb 
      as = 0.
      r = br(nba+1-j)
      call rtfxyz(0,xlat1,xlon1,r,x,y,z)
      call getc(x,y,z,r,xlat1,xlon1,nq,iq,pq,out)
      do 23130 l=1,nq 
      as = as + pq(l)*sol(ioff + iq(l))
23130 continue
      bas = by(nba+1-j,kb)
      if(.not.(relat))goto 23132
      as = 0.1*as/bas
      goto 23133
23132 continue
      as = bas + 0.001*as
23133 continue
      if(.not.(as.gt.asmax))goto 23134
      asmax = as
      elamax = acoor*1.74533e-2
      elomax = r*1.74533e-2
23134 continue
      if(.not.(as.lt.asmin))goto 23136
      asmin = as
      elamin = acoor*1.74533e-2
      elomin = r*1.74533e-2
23136 continue
      if(.not.(black))goto 23138
      cst = 0.
      call getclin(x,y,z,nql,iql,pql,out)
      do 23140 l=1,nql 
      cst = cst + pql(l)*cols(ioff+iql(l))
23140 continue
      if(.not.(cst .lt. cseps))goto 23142
      as = 100000.
      goto 23143
23142 continue
      cmax = max(cmax,cst)
23143 continue
      cs(i,j) = cst
23138 continue
      asav(j) = asav(j) + as
23128 continue
      dmh = 0
      call gett(out,col,xlat1,xlon1,ntr,tt,pp,ni,it,pt)
      do 23144 l=1,ni 
      dmh = dmh + pt(l)*sol(ioffm+it(l))
23144 continue
      dmh = rmoho - 0.001*dmh
      call rotate(1,xlat1,xlon1,rlat,rlon)
      drlat = rlat/1.74533e-2
      drlon = rlon/1.74533e-2
      topo = etopo5web(drlat,drlon)
      topo = 0.001*topo
      topoav = topoav + topo
      dmhav = dmhav + dmh
      call nextcoor(xlat1,xlon1,da,azimuth,xlat2,xlon2)
      acoor = acoor - dacoor
23126 continue
      topoav = topoav/na
      dmhav = dmhav/na
      do 23146 j = 1,nb 
      asav(j) = asav(j)/na
23146 continue
      call fjmoho(nba,br,by(1,1),jjmoho)
      jjmoho = nba + 1 - jjmoho
      write(2,*) -topoav,asav(1)
      do 23148 j = 1,jjmoho-1 
      if(.not.(br(nba+1-j).gt.dmhav.and.(6371.-br(nba+1-j)).gt.-topoav))
&     goto 23150
      write(2,*) 6371.-br(nba+1-j),asav(j)
23150 continue
23148 continue
      write(2,*) 6371.-dmhav,asav(jjmoho)
      write(2,*) 6371.-dmhav,asav(jjmoho+1)
      do 23152 j = jjmoho+2,nb 
      if(.not.(br(nba+1-j).lt.dmhav))goto 23154
      write(2,*) 6371.-br(nba+1-j),asav(j)
23154 continue
23152 continue
      write(6,*) 'written ',slicename
      write(6,*) 'nr of nodes: ',na,nb
      write(6,*) 'spacing (degrees,km): ',dacoor
23120 continue
      if(.not.(iopt .eq. 3))goto 23156
      print*, "slicing..."
      if(.not.(back))goto 23158
      bas = finterp(rshell,br,by(1,kb),nba)
23158 continue
      ea = amin - da
      do 23160 i=1,na 
      ea = ea + da
      eb = bmax + db
      do 23162 j=1,nb 
      as = 0.
      eb = eb - db
      elo = ea
      ela = eb
      call rotate(0,ela,elo,tetaout,fiout)
      call rtfxyz(0,tetaout,fiout,rshell,x,y,z)
      call getc(x,y,z,rshell,tetaout,fiout,nq,iq,pq,out)
      do 23164 l=1,nq 
      as = as + pq(l)*sol(ioff + iq(l))
23164 continue
      if(.not.(back))goto 23166
      if(.not.(relat))goto 23168
      as = 0.1*as/bas
      goto 23169
23168 continue
      as = bas + 0.001*as
23169 continue
23166 continue
      if(.not.(as.gt.asmax))goto 23170
      asmax = as
      elamax = ela
      elomax = elo
23170 continue
      if(.not.(as.lt.asmin))goto 23172
      asmin = as
      elamin = ela
      elomin = elo
23172 continue
      if(.not.(black))goto 23174
      cst = 0.
      call getclin(x,y,z,nql,iql,pql,out)
      do 23176 l=1,nql 
      cst = cst + pql(l)*cols(ioff+iql(l))
23176 continue
      if(.not.(cst .lt. cseps))goto 23178
      as = 100000.
      goto 23179
23178 continue
      cmax = max(cmax,cst)
23179 continue
      cs(i,j) = cst
23174 continue
      asol(i,j) = as
      write(2,*) elo/1.74533e-2,ela/1.74533e-2,as
23162 continue
23160 continue
      write(6,*) 'written ',slicename
      write(6,*) 'nr of nodes: ',na,nb
      write(6,*) 'spacing (degrees): ',da/1.74533e-2,db/1.74533e-2
      open(8,file='spacing')
      write(8,'(f9.5,"/",f9.5)') da/1.74533e-2,db/1.74533e-2
      close(8)
      call mkclrpt(asmin,asmax)
23156 continue
      if(.not.(iopt .eq. -3))goto 23180
      print*, "slicing..."
      ea = amin - da
      do 23182 i=1,na 
      ea = ea + da
      eb = bmax + db
      do 23184 j=1,nb 
      as = 0.
      out = .false.
      eb = eb - db
      elo = ea
      ela = eb
      call rotate(0,ela,elo,tetaout,fiout)
      call gett(out,col,tetaout,fiout,ntr,tt,pp,ni,it,pt)
      do 23186 l=1,ni 
      as = as + pt(l)*sol(ioff+it(l))
23186 continue
      as = 0.001*as
      if(.not.(back))goto 23188
      as = as + 6371. - rmoho
23188 continue
      if(.not.(as.gt.asmax))goto 23190
      asmax = as
      elamax = ela
      elomax = elo
23190 continue
      if(.not.(as.lt.asmin))goto 23192
      asmin = as
      elamin = ela
      elomin = elo
23192 continue
      if(.not.(black))goto 23194
      cst = 0.
      call gettlin(out,col,dmx,tetaout,fiout,ntr,tt,pp,nil,itl,ptl)
      do 23196 l=1,nil 
      cst = cst + ptl(l)*cols(ioff+itl(l))
23196 continue
      if(.not.(cst .lt. cseps))goto 23198
      as = 100000.
      goto 23199
23198 continue
      cmax = max(cmax,cst)
23199 continue
      cs(i,j) = cst
23194 continue
      asol(i,j) = as
      write(2,*) elo/1.74533e-2,ela/1.74533e-2,as
      if(.not.(black))goto 23200
      write(4,*) elo/1.74533e-2,ela/1.74533e-2,cst
23200 continue
23184 continue
23182 continue
      write(6,*) 'written ',slicename
      write(6,*) 'nr of nodes: ',na,nb
      write(6,*) 'spacing (degrees): ',da/1.74533e-2,db/1.74533e-2
      open(8,file='spacing')
      write(8,'(f9.5,"/",f9.5)') da/1.74533e-2,db/1.74533e-2
      close(8)
      call mkclrpt(asmin,asmax)
23180 continue
      if(.not.(iopt .eq. 4))goto 23202
      print*, "rendering..."
      ipatient = 1
      ijk = 0
      z = zmin - dz
      do 23204 k = 1,nz 
      z = z + dz
      y = ymin - dy
      do 23206 j = 1,ny 
      y = y + dy
      x = xmin - dx
      do 23208 i = 1,nx 
      x = x + dx
      ijk = ijk + 1
      as = 0
      if(.not.(ijk .gt. ipatient*50000))goto 23210
      ipatient = ipatient + 1
      write(6,*) 'processed 50000 more knots'
23210 continue
      call rtfxyz(1,tetap,fip,rp,x,y,z)
      call getc(x,y,z,rp,tetap,fip,nq,iq,pq,out)
      do 23212 l=1,nq 
      as = as + pq(l)*sol(ioff + iq(l))
23212 continue
      if(.not.(back))goto 23214
      bas = finterp(rp,br,by(1,kb),nba)
      if(.not.(relat))goto 23216
      as = 0.1*as/bas
      goto 23217
23216 continue
      as = bas + 0.001*as
23217 continue
23214 continue
      if(.not.(as.gt.asmax))goto 23218
      asmax = as
      elamax = tetap
      elomax = fip
23218 continue
      if(.not.(as.lt.asmin))goto 23220
      asmin = as
      elamin = tetap
      elomin = fip
23220 continue
      if(.not.(black))goto 23222
      cst = 0.
      call getclin(x,y,z,nql,iql,pql,out)
      do 23224 l=1,nql 
      cst = cst + pql(l)*cols(ioff+iql(l))
23224 continue
      if(.not.(cst .lt. cseps))goto 23226
      as = 100000.
      goto 23227
23226 continue
      cmax = max(cmax,cst)
23227 continue
      c3d(ijk) = cst
23222 continue
      a3d(ijk) = as
23208 continue
23206 continue
23204 continue
      gmax = max(asmax,-1.*asmin)
      factor = 127.5/gmax
      do 23228 ijk = 1,nsq 
      ntmp = nint(127.5 + a3d(ijk)*factor)
      ntmp = max(ntmp,0)
      ntmp = min(ntmp,255)
      na3d(ijk) = char(ntmp)
23228 continue
      do 23230 ijk = 1,nsq 
      ierr = fputc(2,na3d(ijk))
23230 continue
      open(9,file='Bobfile')
      rewind 9
      write(9,*) "size = ",nx,ny,nz
      write(9,*) "file = ",slicename
      write(9,*) "color = rainbow.palette"
      close(9)
      if(.not.(black))goto 23232
      factor = 254./cmax
      do 23234 ijk = 1,nsq 
      nc3d(ijk) = char(nint(c3d(ijk)*factor))
23234 continue
      do 23236 ijk = 1,nsq 
      ierr = fputc(4,nc3d(ijk))
23236 continue
23232 continue
23202 continue
      if(.not.(iopt .eq. 5))goto 23238
      print*, "rendering..."
      ipatient = 1
      ijk = 0
      r = rdown - dr
      do 23240 k = 1,nr 
      r = r + dr
      a = amin - da
      do 23242 j = 1,na 
      a = a + da
      b = bmin - db
      do 23244 i = 1,nb 
      b = b + db
      ijk = ijk + 1
      as = 0
      if(.not.(ijk .gt. ipatient*50000))goto 23246
      ipatient = ipatient + 1
      write(6,*) 'processed 50000 more knots'
23246 continue
      call rotate(0,a,b,teta,fi)
      call rtfxyz(0,teta,fi,r,x,y,z)
      call getc(x,y,z,r,teta,fi,nq,iq,pq,out)
      do 23248 l=1,nq 
      as = as + pq(l)*sol(ioff + iq(l))
23248 continue
      if(.not.(back))goto 23250
      bas = finterp(r,br,by(1,kb),nba)
      if(.not.(relat))goto 23252
      as = 0.1*as/bas
      goto 23253
23252 continue
      as = bas + 0.001*as
23253 continue
23250 continue
      if(.not.(as.gt.asmax))goto 23254
      asmax = as
      elamax = teta
      elomax = fi
23254 continue
      if(.not.(as.lt.asmin))goto 23256
      asmin = as
      elamin = teta
      elomin = fi
23256 continue
      if(.not.(black))goto 23258
      cst = 0.
      call getclin(x,y,z,nql,iql,pql,out)
      do 23260 l=1,nql 
      cst = cst + pql(l)*cols(ioff+iql(l))
23260 continue
      if(.not.(cst .lt. cseps))goto 23262
      as = 100000.
      goto 23263
23262 continue
      cmax = max(cmax,cst)
23263 continue
      c3d(ijk) = cst
23258 continue
      a3d(ijk) = as
23244 continue
23242 continue
23240 continue
      gmax = max(asmax,-1.*asmin)
      factor = 127.5/gmax
      do 23264 ijk = 1,nsq 
      ntmp = nint(127.5 + a3d(ijk)*factor)
      ntmp = max(ntmp,0)
      ntmp = min(ntmp,255)
      na3d(ijk) = char(ntmp)
23264 continue
      do 23266 ijk = 1,nsq 
      ierr = fputc(2,na3d(ijk))
23266 continue
      open(9,file='Bobfile')
      rewind 9
      write(9,*) "size = ",nb,na,nr
      write(9,*) "file = ",slicename
      write(9,*) "color = rainbow.palette"
      close(9)
      if(.not.(black))goto 23268
      factor = 254./cmax
      do 23270 ijk = 1,nsq 
      nc3d(ijk) = char(nint(c3d(ijk)*factor))
23270 continue
      do 23272 ijk = 1,nsq 
      ierr = fputc(4,nc3d(ijk))
23272 continue
23268 continue
23238 continue
      if(.not.(black))goto 23274
      write(6,*) 'colsm max: ',cmax
23274 continue
      write(6,*) 'asmin, asmax: ',asmin,asmax
      write(6,*) 'at:',elamin/1.74533e-2,elomin/1.74533e-2,' and ',
&     elamax/1.74533e-2,elomax/1.74533e-2
      write(6,*) 'sns finished'
      end
      subroutine mkclrpt(asmin,asmax)
      dimension lors(3,10)
      data (lors(i,1),i=1,3)/170,0,0/
      data (lors(i,2),i=1,3)/255,0,0/
      data (lors(i,3),i=1,3)/255,85,0/
      data (lors(i,4),i=1,3)/255,128,0/
      data (lors(i,5),i=1,3)/255,255,0/
      data (lors(i,6),i=1,3)/255,255,0/
      data (lors(i,7),i=1,3)/30,220,100/
      data (lors(i,8),i=1,3)/0,225,140/
      data (lors(i,9),i=1,3)/0,80,255/
      data (lors(i,10),i=1,3)/0,0,205/
40    format(f10.2,3i4,2x,f10.2,3i4)
41    format(f10.2,3i4,2x,f10.2,3i4,1x,a1)
      limu = nint(max(abs(asmax),abs(asmin)))
      liml = -1*limu
      write(6,*) 'liml, limu: ',liml,limu
      dlim = 2.*limu/(10-1.)
      open(3,file='color.palette')
      rewind 3
      v1 = liml
      v0 = v1
      v1 = v1 + dlim
      write(3,41) v0,lors(1,1),lors(2,1),lors(3,1),v1,lors(1,2),lors(2,
&     2),lors(3,2),'U'
      do 23276 icl=2,10-1 
      v0 = v1
      v1 = v1 + dlim
      write(3,40) v0,lors(1,icl),lors(2,icl),lors(3,icl),v1,lors(1,icl+
&     1),lors(2,icl+1),lors(3,icl+1)
23276 continue
      return
      end
      function finterp(x,xa,ya,n)
      dimension xa(n), ya(n)
      i = 1
      j = i+1
      do 23278 while ((j.le.n) .and. (x.lt.min(xa(i),xa(j)) .or. x.gt.
&     max(xa(i),xa(j)))) 
      i = j
      j = i+1
23278 continue
      if(.not.(j.gt.n))goto 23280
      write(6,*) 'Error: ',x,' not in array'
      finterp = 0.
      return
23280 continue
      abs1 = abs(1.-xa(i)/x)
      abs2 = abs(1.-xa(i-1)/x)
      if(.not.(i.gt.1))goto 23282
      if(.not.(abs1.lt.1.e-6 .and. abs2.lt.1.e-6))goto 23284
      finterp = 0.5*(ya(i) + ya(i-1))
      return
23284 continue
23282 continue
      abs1 = abs(1.-xa(i)/x)
      abs2 = abs(1.-xa(i+1)/x)
      if(.not.(i.lt.n))goto 23286
      if(.not.(abs1.lt.1.e-6 .and. abs2.lt.1.e-6))goto 23288
      finterp = 0.5*(ya(i) + ya(i+1))
      return
23288 continue
23286 continue
      abs1 = abs(1.-xa(j)/x)
      abs2 = abs(1.-xa(j-1)/x)
      if(.not.(j.gt.1))goto 23290
      if(.not.(abs1.lt.1.e-6 .and. abs2.lt.1.e-6))goto 23292
      finterp = 0.5*(ya(j) + ya(j-1))
      return
23292 continue
23290 continue
      abs1 = abs(1.-xa(j)/x)
      abs2 = abs(1.-xa(j+1)/x)
      if(.not.(j.lt.n))goto 23294
      if(.not.(abs1.lt.1.e-6 .and. abs2.lt.1.e-6))goto 23296
      finterp = 0.5*(ya(j) + ya(j+1))
      return
23296 continue
23294 continue
      x0 = xa(i)
      y0 = ya(i)
      x1 = xa(j)
      y1 = ya(j)
      finterp = (x-x0)*(y1-y0)/(x1-x0) + y0
      return
      end
      subroutine fjmoho(n,r,vp,jjmoho)
      dimension r(n),vp(n)
      jjmoho = 0
      i=n
      do 23298 while (vp(i).lt.4) 
      i=i-1 
23298 continue
      do 23300 while ((vp(i-1)-vp(i)).le.1.2) 
      i=i-1
23300 continue
      if(.not.(r(i).eq.r(i-1)))goto 23302
      jjmoho = i 
23302 continue
      write(6,*) ''
      write(6,*) "moho depth?: ", 6371. - 0.001*r(jjmoho)," km"
      return
      end
