subroutine checkgt(nr,r,maxtyp,npar,gtmax,gtilde,skip,jflag,stdev,qpar)
include defines
# checks the maximum of gtilde for S-velocities with a cut-off value.
# if this is small, the other gtildes will also be slow.
# the cut-off value is user-defined. The example of 5e-8 is based on 
# synthetic tests, so that only 9 significant constraints remain per path.

dimension jflag(nrfpr)
dimension r(nr)
dimension gtilde(mxnds,nrfpr,maxp)
dimension stdev(npar),qpar(npar)
logical skip

i = 1
io = 0
do while (i <= npar) {
   io = io + 1
   gmx = 0.
   do j=1,4 {
      if (jflag(j) != 0) {
         do l=1,nr {
	    gmx = max(gmx,abs(gtilde(l,j,i)))
	 }
      }
   }

   if (gmx < gtmax) {
      write(6,*) 'constraint ',io,' dropped', qpar(i)
      npar = npar-1
      do ii = i,npar {
	 qpar(ii) = qpar(ii+1)
	 stdev(ii) = stdev(ii+1)
	 do j = 1,maxtyp {
	    do l=1,nr {
	       gtilde(l,j,ii) = gtilde(l,j,ii+1) }}
      }
   } else {
      i = i+1
   }
}
if (npar < 1) skip=.true.
       
return
end
