      subroutine dpror(mode,m,n,x,y,leniw,lenrw,iw,rw,cft,cfi,matrix)
c computes y = y + A x if mode=1
c computes x = x + A^T y if mode=2
c at each call apror reads the matrix A from file to save memory.

      implicit none
      integer m, n, leniw, lenrw
      integer iw(leniw), mode
      real x(n), y(m)
      real rw(lenrw)
      integer ic, npar, nz, i, k, ifs, nif, ifsin
      integer kend,kknd
      real depsilon
      real cft(n),cfi(n)
*      real rf(m),rfk
      character*50 matrix

      common/nrs/nif,depsilon

      open(3,file=matrix,form='unformatted',status = 'old')
      rewind 3

      ic = 0
      do ifs=1,nif
         read(3,end=200) ifsin, npar, nz
	 if (ifsin.ne.ifs) write(6,*) 'error: ',ifs,' ! = ',ifsin 
         read(3,end=200) (iw(i),i=1,nz)
         do k = ic+1,ic+npar
**	   rfk = rf(k)
           read(3,end=200) (rw(i),i=1,nz)
	   do i=1,nz 
	      if (mode.eq.1) then
*	         y(k) = y(k) + cf(iw(i))*rw(i)*x(iw(i)) 
**	         y(k) = y(k) + cft(iw(i))*rw(i)*rfk*x(iw(i)) 
	         y(k) = y(k) + cft(iw(i))*rw(i)*x(iw(i)) 
              endif
	      if (mode.eq.2) then
*	         x(iw(i)) = x(iw(i)) + cf(iw(i))*rw(i)*y(k)
**	         x(iw(i)) = x(iw(i)) + cft(iw(i))*rw(i)*rfk*y(k)
	         x(iw(i)) = x(iw(i)) + cft(iw(i))*rw(i)*y(k)
	      endif
           enddo
         enddo
	 ic = ic + npar
      enddo
      kend = ic
      do k=kend+1,m 
	 kknd = k - kend
         if (mode.eq.1) then
*            y(k) = y(k) + depsilon*cf(kknd)*x(kknd)
* same row scaling as above (rf should contain depsilon):
**            y(k) = y(k) + cfi(kknd)*rf(k)*x(kknd)
            y(k) = y(k) + cfi(kknd)*depsilon*x(kknd)
         endif
	 if (mode.eq.2) then
*	    x(kknd) = x(kknd) + depsilon*cf(kknd)*y(k)
**	    x(kknd) = x(kknd) + cfi(kknd)*rf(k)*y(k)
	    x(kknd) = x(kknd) + cfi(kknd)*depsilon*y(k)
	 endif
      enddo

      close(3)
      return

200   write(6,*) 'premature end to file matrix'
      write(6,*) 'nif= ',nif,' ic= ',ic
      return
      end
