c . . return interpolated topography value
      real function etopo5(lat,lon)
      implicit undefined(a-z)
      real lat, lon

c . . topographic database parameters
      integer lonum
      parameter (lonum=4320+1)

c . . number of grid points per degree
      real factor
      parameter(factor=12.0)
      integer*2 latit,itopo(lonum)
      character*72 topofl
      integer reclen, jrec1, jrec2, ilon, n
      real topo(2,2), xdist, ydist
      real rlat1, rlat2, rlon1, rlon2

      if(lat.lt.-90.0.or.lat.gt.90.0)then
        write(0,'(a)')'etopo5: latitude outside domain -90.0 -> 90.0'
      endif
      jrec1 = int((90.0-lat)*factor)+2
      jrec2 = int((90.0-lat)*factor)+1
      rlat1 = 90.0-(jrec1-1)/factor
      rlat2 = 90.0-(jrec2-1)/factor

      if(lon.lt.0.0)then
        ilon = int((lon+360.)*factor) + 1
      else
        ilon = int(lon*factor) + 1
      endif
      rlon1 = (ilon-1)/factor
      rlon2 = (ilon)/factor

c . . open inputfile
c      topofl = '/usr/local/common/input/etopo5.bin'
      topofl = '/data/08/federica/SRC/PWI/input/etopo5.bin'
      reclen=(lonum+1)*2
* On the SGI the reclen is in multiples of 4 bytes, i.e. (4320+1+1)*2/4 = 2161
*      reclen=2161
      open(49,file=topofl,form='unformatted',access='direct',
     &   recl=reclen)

      read(49,rec=jrec1)latit, (itopo(n),n=1,lonum)
      topo(1,1) = itopo(ilon)
      topo(2,1) = itopo(ilon+1)
      read(49,rec=jrec2)latit, (itopo(n),n=1,lonum)
      topo(1,2) = itopo(ilon)
      topo(2,2) = itopo(ilon+1)
      close(49)

      ydist = (lat-rlat1)*factor
      if(lon.lt.0.0)then
        xdist = (360.0+lon-rlon1)*factor
      else
        xdist = (lon-rlon1)*factor
      endif

      etopo5 = topo(1,1)*(1.0-xdist)*(1.0-ydist)
      etopo5 = etopo5 + topo(2,1)*xdist*(1.0-ydist)
      etopo5 = etopo5 + topo(1,2)*(1.0-xdist)*ydist
      etopo5 = etopo5 + topo(2,2)*xdist*ydist
      etopo5 = etopo5/((1.0-xdist)*(1.0-ydist) + xdist*(1.0-ydist) +
     &   (1.0-xdist)*ydist + xdist*ydist)
      return
      end
