      subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
      dimension i(300),f(300)
      dimension i8(8),f8(8)
      dimension wc(4)
      logical out
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      np = 0
      do 23000 l = 1,300 
      i(l) = 0
      f(l) = 0. 
23000 continue
      r0 = rp
      t0 = tp
      f0 = fp
      x0 = xp
      y0 = yp
      z0 = zp
      out = .false.
      if(.not.(x0 .lt. xmin .or. x0 .gt. xmax .or. y0 .lt. ymin .or. y0 
&     .gt. ymax .or. z0 .lt. zmin .or. z0 .gt. zmax))goto 23002
      out = .true.
      return
23002 continue
      call trilin(x0,y0,z0,n8,i8,f8)
      do 23004 l=1,n8 
      call addif(i8(l),f8(l),w0,np,i,f)
23004 continue
      na = 0
      dcst = 0.
      az = 0.
      do 23006 k = 1,ksteps 
      na = na + mazi
      daz = 2.*3.1415926535897932/na
      az = az + 0.5*daz
      dcst = dcst + step
      wk = wc(k)
      do 23008 ia = 1,na 
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do 23010 l=1,n8 
      call addif(i8(l),f8(l),wk,np,i,f)
23010 continue
23008 continue
23006 continue
      return
      end
      subroutine trilin(xq,yq,zq,n8,i8,f8)
      dimension i8(8),f8(8)
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      if(.not.(xq .lt. xmin .or. xq .gt. xmax .or. yq .lt. ymin .or. yq 
&     .gt. ymax .or. zq .lt. zmin .or. zq .gt. zmax))goto 23012
      n8 = 0
      return
23012 continue
      n8 = 8
23013 continue
      xdist = (xq - xmin)/dx
      ydist = (ymax - yq)/dy
      zdist = (zmax - zq)/dz
      ixmn = int(xdist) + 1
      ixmx = ixmn + 1
      if(.not.(ixmn .eq. nx))goto 23014
      ixmx = ixmn
      ixmn = ixmx - 1 
23014 continue
      iymn = int(ydist) + 1
      iymx = iymn + 1
      if(.not.(iymn .eq. ny))goto 23016
      iymx = iymn
      iymn = iymx - 1 
23016 continue
      izmn = int(zdist) + 1
      izmx = izmn + 1
      if(.not.(izmn .eq. nz))goto 23018
      izmx = izmn
      izmn = izmx - 1 
23018 continue
      lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn
      i8(1) = lub
      i8(2) = lub + 1
      i8(3) = lub + nx
      i8(4) = i8(3) + 1
      i8(5) = lub + nxy
      i8(6) = i8(5) + 1
      i8(7) = i8(5) + nx
      i8(8) = i8(7) + 1
      x = xdist - (ixmn-1)
      y = (iymx-1) - ydist
      z = (izmx-1) - zdist
      xy = x*y
      xz = x*z
      yz = y*z
      xyz = xy*z
      f8(1) = yz - xyz
      f8(2) = xyz
      f8(3) = z - yz - xz + xyz
      f8(4) = xz - xyz
      f8(5) = y - xy - yz + xyz
      f8(6) = xy - xyz
      f8(7) = 1 - x - y - z + xy + yz + xz - xyz
      f8(8) = x - xy - xz + xyz
      return
      end
      subroutine wrers(xp,yp,zp,x,y,z)
      write(6,*) "DANGER: path is not completely in grid:"
      write(6,*) "x was ",xp," y was ",yp," z was ",zp
      write(6,*) "x is ",x," y is ",y," z is ",z
      write(6,*) "outward structure set to zero."
      return
      end
      subroutine addif(iin,fin,wt,n,iarr,farr)
      dimension iarr(300), farr(300)
      jl = 0
      ju = n + 1
      do 23020 while ((ju-jl) .gt. 1) 
      jm = (ju+jl)/2
      if(.not.(iin .gt. iarr(jm)))goto 23022
      jl = jm
      goto 23023
23022 continue
      ju = jm
23023 continue
23020 continue
      if(.not.(iin .eq. iarr(ju)))goto 23024
      farr(ju) = farr(ju) + wt*fin
      goto 23025
23024 continue
      n = n + 1
      do 23026 j = n,ju+1,-1 
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
23026 continue
      iarr(ju) = iin
      farr(ju) = wt*fin
23025 continue
      return
      end
