subroutine gett(out,col,ela,elo,ntr,tt,pp,nl,i,f)
include defines
include sdefines
dimension tt(mxtr), pp(mxtr)
dimension i(nonzsm), f(nonzsm) 
dimension ds(nonzsm),wt(nonzsm)
dimension ka(12000)
dimension wc(kmax)
logical out
common/smooth/st,step,ksteps,mazi,w0,wc

# determine if node inside area:
range = 0.5*pi - ela
if (range > col | out) {
   #write(6,*) 'warning: coordinates fall OUTSIDE triangular grid'
   out = .true.
   nl = 0
   return
}

# determine closed-in area in which to search for closest nodes:
de = st*2
range = 0.5*pi - de
tmin = ela - de
cela = cos(ela)
  
ik = 0
if (ela > range) {
   do k = 1,ntr {
      if (tt(k) >= tmin) {
         ik = ik + 1
         ka(ik) = k
      }
   }
} else {
   do k = 1,ntr {
      ttabs = abs (tt(k) - ela)
      if (ttabs <= de) {
         ppelo = pp(k) - elo
         ppabs = min(abs(ppelo),abs(ppelo+2.*pi),abs(ppelo-2.*pi))
	 ppabs = ppabs*cela
         if (ppabs <= de) {
            ik = ik + 1
            ka(ik) = k
         }
      }
   }
}
nk = ik
if (nk == 0) { 
   #write(6,*) 'ERROR: nk = 0! for:',ela/p,elo/p 
   nl = 0
   return
}

#print*, "nk=",nk
 
# find a number (nl) of closest vertices:
nl = 0
do ik=1,nk {
   call deltas(delta,tt(ka(ik)),pp(ka(ik)),ela,elo)
   if (delta < st) { 
      nl = nl+1
      ds(nl) = delta      
      i(nl) = ka(ik)
   }
}

if (nl > nonzsm) {
   write(6,*) 'ERROR: nl >',nonzsm,' for ela,elo = ',ela/p,elo/p
   write(6,*) 'array dimension exceeded!'
} 

# choose linear basis functions and
# weight the total influence of these vertices to 1:
wsum = 0
do l=1,nl {
   wt(l) = (st - ds(l))/st
   wsum = wsum + wt(l)
}
do l=1,nl {
   f(l) = wt(l)/wsum
}

return
end
