program glue0
# converts point matrix to constraint-format matrix
include sdefines

dimension it(nonzsm),pt(nonzsm)

write(6,*) "Move psizeofmatrix to sizeofmatrix!"

open(2,file='matrix',status='new',form='unformatted')
open(7,file='rhs',status='new')
open(3,file='prhs',status='old')
open(4,file='pmatrix',status='old')
rewind 3
rewind 4

# expected stdev in receiver functions sigma = 3000
# expected stdev in S velocity sigma = 225
write(6,*)'give uncertainty in constraint (e.g. 3000):'
read(5,*) sigma
write(6,*)'sigma= ',sigma
ntmax=0

i = 0
100 continue
  read(3,*,end=200) pot
  i = i+1
  pot = pot/sigma
  read(4,*)idata,idum,nt
  if(idata != i) {
     print*, 'idata ',idata,' not equal to i ',i
     stop 
  }
  if(idum != 1) stop 'idum not equal to 1'
  ntmax=max(nt,ntmax)
  read(4,*) (it(j),j=1,nt)
  read(4,*) (pt(j),j=1,nt)

# row scaling
    do k=1,nt {
       pt(k) = pt(k)/sigma
    }

  write(7,*) pot
  write(2)idata+nif,idum,nt
  write(2)(it(j),j=1,nt)
  write(2)(pt(j),j=1,nt)
goto 100
200 continue
nd = i
print*, "nd=",nd

end
