      program makeeu
      character*7 fname
      dimension solution(13e5)
      dimension jy(5),jn(5),apu(5)
      dimension ia(30000),fa(30000)
      dimension spkdp(1),spkla(60),spklo(60)
      dimension spikdp(1),spikla(2),spiklo(2)
      dimension wc(10)
      dimension xnode(13e5),ynode(13e5)
      logical out
      real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
      data itypes/2/
      data spikdp/100/
      data spikla/-21,-5/
      data spiklo/-47,-63/
      data spkdp/500./
      data spkla /46.,46.,46.,46.,46.,46.,46.,46.,46.,46.,46.,46.,37.,
&     37.,37.,37.,37.,37.,37.,37.,37.,37.,37.,37.,28.,28.,28.,28.,28.,
&     28.,28.,28.,28.,28.,28.,28.,19.,19.,19.,19.,19.,19.,19.,19.,19.,
&     19.,19.,19.,10.,10.,10.,10.,10.,10.,10.,10.,10.,10.,10.,10./
      data spklo /-35.,-25.,-15.,-5.,5.,15.,25.,35.,45.,55.,65.,75.,-35.
&     ,-25.,-15.,-5.,5.,15.,25.,35.,45.,55.,65.,75.,-35.,-25.,-15.,-5.,
&     5.,15.,25.,35.,45.,55.,65.,75.,-35.,-25.,-15.,-5.,5.,15.,25.,35.,
&     45.,55.,65.,75.,-35.,-25.,-15.,-5.,5.,15.,25.,35.,45.,55.,65.,75./
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      do 23000 i=1,13e5 
      solution(i) = 0.
23000 continue
      call setgrid(ddd,avdd,distmax)
      open(1,file='model.shell',status='old')
      rewind(1)
      read(1,*) ntr,nt,imx,dmxd,cold,rmoho
      write(6,*) nsq,' nodes in 3D model'
      close(1)
      call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
      n=0
      j=1
      do 23002 while (jy(j) .lt. itypes) 
      n = n+1
      j = j+1
23002 continue
      if(.not.(jy(j) .ne. itypes))goto 23004
      write(6,*) 'Sorry, your data do not include S-velocities,'
      write(6,*) 'I will not compute a synthetic S-velocity model.'
      stop
23004 continue
      apus=apu(j)
      ioff=n
      noff = ioff*nsq
      ncol = njy*nsq + jmoho*ntr
      write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol
      dsol = 300.
      stk = 400.
      st = stk/6371.
      step = 60./6371.
      call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
      do 23006 k=1,1 
      r = 6371. - spkdp(k)
      print*, "layer at",r, " dsol=",dsol
      do 23008 j=1,60 
      plat = 1.74533e-2*spkla(j)
      plon = 1.74533e-2*spklo(j)
      call rotate(0,plat,plon,tt,ft)
      call rtfxyz(0,tt,ft,r,x,y,z)
      call getc(x,y,z,r,tt,ft,np,ia,fa,out)
      if(.not.(out))goto 23010
      print*, 'error, out is true'
23010 continue
      do 23012 i = 1,np 
      solution(ia(i)) = solution(ia(i)) + dsol
23012 continue
      dsol = -1.*dsol
      if(.not.(j .eq. 12))goto 23014
      dsol = -1.*dsol
23014 continue
      if(.not.(j .eq. 24))goto 23016
      dsol = -1.*dsol
23016 continue
      if(.not.(j .eq. 36))goto 23018
      dsol = -1.*dsol
23018 continue
      if(.not.(j .eq. 48))goto 23020
      dsol = -1.*dsol
23020 continue
      if(.not.(j .eq. 60))goto 23022
      dsol = -1.*dsol
23022 continue
23008 continue
23006 continue
      smin = 0
      smax = 0
      do 23024 i=1,ncol 
      smax = max(solution(i),smax)
      smin = min(solution(i),smin)
23024 continue
      write(6,*) 'min,max solution:',smin,smax
      fname = "syn.p00"
      open(1,file=fname,status='replace')
      rewind 1
      write(1,*) ncol
      write(1,*) (solution(i),i=1,ncol)
      close(1)
      kdp = 1
      jspk = 0
      dsol = -300.
      end
      subroutine slab1(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23026
      return
23026 continue
      if(.not.(lat .lt. 34. .or. lat .gt. 43.))goto 23028
      return
23028 continue
      lon0 = 0.44*(83.75-lat)
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 2.0 + 10.7))goto 23030
      return
23030 continue
      llon0 = lon0 + (rup-r)*10.7/660.
      rlon0 = llon0 + 2.0
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23032
      return
23032 continue
      s(k) = dbeta
      return
      end
      subroutine slab1neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23034
      return
23034 continue
      if(.not.(lat .lt. 34. .or. lat .gt. 43.))goto 23036
      return
23036 continue
      lon0 = 0.44*(83.75-lat) + 2.0
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 2.0 + 10.7))goto 23038
      return
23038 continue
      llon0 = lon0 + (rup-r)*10.7/660.
      rlon0 = llon0 + 2.0
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23040
      return
23040 continue
      s(k) = dbeta
      return
      end
      subroutine slab2(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23042
      return
23042 continue
      if(.not.(lat .lt. 36. .or. lat .gt. 40.))goto 23044
      return
23044 continue
      lon0 = 0.75*(lat-17)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 7.7))goto 23046
      return
23046 continue
      llon0 = lon0 - (rup-r)*7.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23048
      return
23048 continue
      s(k) = dbeta
      return
      end
      subroutine slab2neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23050
      return
23050 continue
      if(.not.(lat .lt. 36. .or. lat .gt. 40.))goto 23052
      return
23052 continue
      lon0 = 0.75*(lat-17) - 1.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 1.5 - 7.7))goto 23054
      return
23054 continue
      llon0 = lon0 - (rup-r)*7.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23056
      return
23056 continue
      s(k) = dbeta
      return
      end
      subroutine slab3(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23058
      return
23058 continue
      if(.not.(lat .lt. 40. .or. lat .gt. 45.))goto 23060
      return
23060 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 10.7))goto 23062
      return
23062 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23064
      return
23064 continue
      s(k) = dbeta
      return
      end
      subroutine slab3neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23066
      return
23066 continue
      if(.not.(lat .lt. 40. .or. lat .gt. 45.))goto 23068
      return
23068 continue
      lon0 = 1.25*(56.4-lat) - 2.0 - 1.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 10.7))goto 23070
      return
23070 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23072
      return
23072 continue
      s(k) = dbeta
      return
      end
      subroutine slab4(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lat0
      real lat,lon
      data rup /6171./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23074
      return
23074 continue
      if(.not.(lon .lt. -3. .or. lon .gt. 3.))goto 23076
      return
23076 continue
      lat0 = 37.
      if(.not.(lat .lt. lat0 .or. lat .gt. lat0 + 2.0 + 7.5))goto 23078
      return
23078 continue
      llat0 = lat0 + (rup-r)*7.5/460.
      rlat0 = llat0 + 2.0
      if(.not.(lat .lt. llat0 .or. lat .gt. rlat0))goto 23080
      return
23080 continue
      s(k) = dbeta
      return
      end
      subroutine slab4neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lat0
      real lat,lon
      data rup /6171./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23082
      return
23082 continue
      if(.not.(lon .lt. -3. .or. lon .gt. 3.))goto 23084
      return
23084 continue
      lat0 = 37. + 2.0
      if(.not.(lat .lt. lat0 .or. lat .gt. lat0 + 2.0 + 7.5))goto 23086
      return
23086 continue
      llat0 = lat0 + (rup-r)*7.5/460.
      rlat0 = llat0 + 2.0
      if(.not.(lat .lt. llat0 .or. lat .gt. rlat0))goto 23088
      return
23088 continue
      s(k) = dbeta
      return
      end
      subroutine wedge1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6171./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23090
      return
23090 continue
      if(.not.(lat .lt. 34 .or. lat .gt. 43))goto 23092
      return
23092 continue
      lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 2.0
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 4.))goto 23094
      return
23094 continue
      llon0 = lon0 + (rup-r)*4./257.
      rlon0 = lon0 + 4.
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23096
      return
23096 continue
      s(k) = dbeta
      return
      end
      subroutine wedge2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6163./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23098
      return
23098 continue
      if(.not.(lat .lt. 36 .or. lat .gt. 40))goto 23100
      return
23100 continue
      lon0 = 0.75*(lat-17) - 2.5 - 1.0 - 2.0
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 4.))goto 23102
      return
23102 continue
      llon0 = lon0 - (rup-r)*4./257.
      rlon0 = lon0 - 4.
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23104
      return
23104 continue
      s(k) = dbeta
      return
      end
      subroutine wedge3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6113./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23106
      return
23106 continue
      if(.not.(lat .lt. 40 .or. lat .gt. 45))goto 23108
      return
23108 continue
      lon0 = 1.25*(56.4-lat) - 2.0 - 2.0
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 4.))goto 23110
      return
23110 continue
      llon0 = lon0 - (rup-r)*4./257.
      rlon0 = lon0 - 4.
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23112
      return
23112 continue
      s(k) = dbeta
      return
      end
      subroutine wedge4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6113./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23114
      return
23114 continue
      if(.not.(lat .lt. 44 .or. lat .gt. 48))goto 23116
      return
23116 continue
      lon0 = 1.25*(58.2-lat)
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 8.))goto 23118
      return
23118 continue
      s(k) = dbeta
      return
      end
      subroutine wedge5(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6171./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23120
      return
23120 continue
      if(.not.(lat .lt. 34 .or. lat .gt. 43))goto 23122
      return
23122 continue
      lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 1.0 + 4.
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 8.))goto 23124
      return
23124 continue
      s(k) = dbeta
      return
      end
      subroutine wedge6(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6306./
      data rdown /6193./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23126
      return
23126 continue
      if(.not.(lat .lt. 38 .or. lat .gt. 44))goto 23128
      return
23128 continue
      lon0 = 1.25*(56.4-lat) - 2.5 - 1.0 - 7.
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 14.))goto 23130
      return
23130 continue
      lat0 = 0.72*lon + 39.8
      if(.not.(lat .gt. lat0))goto 23132
      return
23132 continue
      s(k) = dbeta
      return
      end
      subroutine wedge7(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6306./
      data rdown /6193./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23134
      return
23134 continue
      if(.not.(lat .lt. 36 .or. lat .gt. 38))goto 23136
      return
23136 continue
      if(.not.(lon .gt. 9. .or. lon .lt. -2.5))goto 23138
      return
23138 continue
      s(k) = dbeta
      return
      end
      subroutine crust1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6331./
      data dbeta /-1300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23140
      return
23140 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 31))goto 23142
      return
23142 continue
      if(.not.(lon .gt. 36 .or. lon .lt. 24))goto 23144
      return
23144 continue
      s(k) = dbeta
      return
      end
      subroutine crust2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23146
      return
23146 continue
      if(.not.(lat .gt. 45 .or. lat .lt. 38))goto 23148
      return
23148 continue
      if(.not.(lon .gt. 20 .or. lon .lt. 9))goto 23150
      return
23150 continue
      s(k) = dbeta
      return
      end
      subroutine crust3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23152
      return
23152 continue
      if(.not.(lat .gt. 45 .or. lat .lt. 38))goto 23154
      return
23154 continue
      if(.not.(lon .gt. 28 .or. lon .lt. 21))goto 23156
      return
23156 continue
      s(k) = dbeta
      return
      end
      subroutine crust4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23158
      return
23158 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23160
      return
23160 continue
      if(.not.(lon .gt. 28 .or. lon .lt. 21))goto 23162
      return
23162 continue
      s(k) = dbeta
      return
      end
      subroutine crust5(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23164
      return
23164 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23166
      return
23166 continue
      if(.not.(lon .gt. 20 .or. lon .lt. 9))goto 23168
      return
23168 continue
      s(k) = dbeta
      return
      end
      subroutine crust6(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23170
      return
23170 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23172
      return
23172 continue
      if(.not.(lon .gt. 8 .or. lon .lt. 0))goto 23174
      return
23174 continue
      s(k) = dbeta
      return
      end
      subroutine constant(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6331./
      data rdown /6276./
      data dbeta /555./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23176
      return
23176 continue
      if(.not.(lat .lt. 20 .or. lat .gt. 50))goto 23178
      return
23178 continue
      if(.not.(lon .lt. -35 .or. lon .gt. 40.))goto 23180
      return
23180 continue
      s(k) = dbeta
      return
      end
      subroutine vertical(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5371./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23182
      return
23182 continue
      if(.not.(lat .lt. 20. .or. lat .gt. 50.))goto 23184
      return
23184 continue
      if(.not.(lon .lt. -35. .or. lon .gt. 40.))goto 23186
      return
23186 continue
      s(k) = dbeta
      return
      end
      subroutine vertical1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5371./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23188
      return
23188 continue
      if(.not.(lat .lt. 38. .or. lat .gt. 40.))goto 23190
      return
23190 continue
      if(.not.(lon .lt. 10. .or. lon .gt. 12.))goto 23192
      return
23192 continue
      s(k) = dbeta
      return
      end
      subroutine vertical2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5371./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23194
      return
23194 continue
      if(.not.(lat .lt. 38. .or. lat .gt. 40.))goto 23196
      return
23196 continue
      if(.not.(lon .lt. 18. .or. lon .gt. 20.))goto 23198
      return
23198 continue
      s(k) = dbeta
      return
      end
      subroutine vertical3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5371./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23200
      return
23200 continue
      if(.not.(lat .lt. 42. .or. lat .gt. 44.))goto 23202
      return
23202 continue
      if(.not.(lon .lt. 14. .or. lon .gt. 16.))goto 23204
      return
23204 continue
      s(k) = dbeta
      return
      end
      subroutine vertical4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5371./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23206
      return
23206 continue
      if(.not.(lat .lt. 36. .or. lat .gt. 38.))goto 23208
      return
23208 continue
      if(.not.(lon .lt. 14. .or. lon .gt. 16.))goto 23210
      return
23210 continue
      s(k) = dbeta
      return
      end
      subroutine transition(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6021./
      data rdown /5671./
      data dbeta /-300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23212
      return
23212 continue
      if(.not.(lat .lt. 35. .or. lat .gt. 38.))goto 23214
      return
23214 continue
      if(.not.(lon .lt. 16. .or. lon .gt. 22.))goto 23216
      return
23216 continue
      s(k) = dbeta
      return
      end
      subroutine transition1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6071./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23218
      return
23218 continue
      if(.not.(lat .lt. 35. .or. lat .gt. 36.5))goto 23220
      return
23220 continue
      if(.not.(lon .lt. -5. .or. lon .gt. 12.))goto 23222
      return
23222 continue
      s(k) = dbeta
      return
      end
      subroutine transition2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6021./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23224
      return
23224 continue
      if(.not.(lat .lt. 38 .or. lat .gt. 42))goto 23226
      return
23226 continue
      lon0 = lat - 37.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 3.))goto 23228
      return
23228 continue
      s(k) = dbeta
      return
      end
      subroutine transition3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23230
      return
23230 continue
      if(.not.(lat .lt. 43. .or. lat .gt. 46.5))goto 23232
      return
23232 continue
      lon0 = ((lat - 75.166)/(-1.166)) - 3.
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 5))goto 23234
      return
23234 continue
      s(k) = dbeta
      return
      end
      subroutine transition4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23236
      return
23236 continue
      if(.not.(lat .lt. 43. .or. lat .gt. 46.5))goto 23238
      return
23238 continue
      lon0 = ((lat - 75.166)/(-1.166)) - 8.
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0))goto 23240
      return
23240 continue
      if(.not.(lat .lt. 39. .or. lat .gt. 42.5))goto 23242
      return
23242 continue
      lon0 = ((lat - 75.166)/(-1.166)) - 3.
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 5))goto 23244
      return
23244 continue
      s(k) = dbeta
      return
      end
      subroutine transition5(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23246
      return
23246 continue
      if(.not.(lat .lt. 34.5 .or. lat .gt. 47.5))goto 23248
      return
23248 continue
      lon0 = lat - 35.5
      lon1 = (lat - 43.75)*(-8/7)
      if(.not.(lon .gt. lon1 + 2. .or. lon .lt. lon0 - 13.))goto 23250
      return
23250 continue
      lat0 = -0.2*lon + 43.3
      if(.not.(lat .gt. lat0 .or. lat .lt. lat0 - 5.))goto 23252
      return
23252 continue
      s(k) = dbeta
      return
      end
      subroutine transition6(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23254
      return
23254 continue
      if(.not.(lon .lt. 18. .or. lon .gt. 21.))goto 23256
      return
23256 continue
      if(.not.(lat .lt. 44. .or. lat .gt. 47.))goto 23258
      return
23258 continue
      s(k) = dbeta
      return
      end
      subroutine transition7(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23260
      return
23260 continue
      if(.not.(lon .lt. 22. .or. lon .gt. 25.))goto 23262
      return
23262 continue
      if(.not.(lat .lt. 40. .or. lat .gt. 43.))goto 23264
      return
23264 continue
      s(k) = dbeta
      return
      end
      subroutine transition8(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23266
      return
23266 continue
      if(.not.(lat .lt. 37. .or. lat .gt. 43.))goto 23268
      return
23268 continue
      lon1 = (50. - lat)*1.5
      if(.not.(lon .gt. lon1 .or. lon .lt. lon1 - 3.))goto 23270
      return
23270 continue
      s(k) = dbeta
      return
      end
      subroutine transition9(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5921./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23272
      return
23272 continue
      if(.not.(lat .lt. 35. .or. lat .gt. 42.))goto 23274
      return
23274 continue
      lon0 = (45. - lat)*1.3
      lon1 = lat - 40.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon1))goto 23276
      return
23276 continue
      s(k) = dbeta
      return
      end
      subroutine transition10(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /5971./
      data rdown /5671./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23278
      return
23278 continue
      if(.not.(lat .lt. 33. .or. lat .gt. 45.))goto 23280
      return
23280 continue
      if(.not.(lon .gt. 17. .or. lon .lt. -10.))goto 23282
      return
23282 continue
      s(k) = dbeta
      return
      end
      subroutine transition11(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6021./
      data rdown /5771./
      data dbeta /300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23284
      return
23284 continue
      if(.not.(lat .lt. 39. .or. lat .gt. 41.))goto 23286
      return
23286 continue
      if(.not.(lon .lt. -1. .or. lon .gt. 1.))goto 23288
      return
23288 continue
      s(k) = dbeta
      return
      end
      subroutine asteno(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6271./
      data rdown /6121./
      data dbeta /-300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23290
      return
23290 continue
      if(.not.(lat .lt. 35. .or. lat .gt. 45.))goto 23292
      return
23292 continue
      if(.not.(lon .gt. 10. .or. lon .lt. -5.))goto 23294
      return
23294 continue
      s(k) = dbeta
      return
      end
      subroutine asteno1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6271./
      data rdown /6121./
      data dbeta /-300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23296
      return
23296 continue
      if(.not.(lat .lt. 42. .or. lat .gt. 48.))goto 23298
      return
23298 continue
      if(.not.(lon .gt. 23. .or. lon .lt. 17.))goto 23300
      return
23300 continue
      s(k) = dbeta
      return
      end
      subroutine crete1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6271./
      data rdown /5671./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23302
      return
23302 continue
      lat0 = 35.
      if(.not.(lon .gt. 26. .or. lon .lt. 21.))goto 23304
      return
23304 continue
      llat0 = lat0 + (rup-r)*2/700.
      rlat0 = llat0 + 1.5
      if(.not.(lat .lt. llat0 .or. lat .gt. rlat0))goto 23306
      return
23306 continue
      s(k) = dbeta
      return
      end
      subroutine crete2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6271./
      data rdown /5671./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23308
      return
23308 continue
      if(.not.(lat .gt. 36.0 .or. lat .lt. 34.5))goto 23310
      return
23310 continue
      if(.not.(lon .gt. 27. .or. lon .lt. 22.))goto 23312
      return
23312 continue
      s(k) = dbeta
      return
      end
      subroutine crete3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6000./
      data rdown /5671./
      data dbeta /600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23314
      return
23314 continue
      if(.not.(lon .lt. 26. .or. lon .gt. 28.0))goto 23316
      return
23316 continue
      if(.not.(lat .gt. 40.5 .or. lat .lt. 39.0))goto 23318
      return
23318 continue
      s(k) = dbeta
      return
      end
      subroutine tirreno(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6371./
      data rdown /5671./
      data dbeta /900./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23320
      return
23320 continue
      if(.not.(lon .lt. 13. .or. lon .gt. 19.0))goto 23322
      return
23322 continue
      lat0 = 0.6 * lon + 26.2
      if(.not.(lat .lt. lat0 .or. lat .gt. lat0 + 2.0 + 10.))goto 23324
      return
23324 continue
      rlat0 = lat0 + 2.5 + (rup-r) * 2.0/600.
      llat0 = rlat0 + 0.7
      if(.not.(lat .gt. llat0 .or. lat .lt. rlat0))goto 23326
      return
23326 continue
      s(k) = dbeta
      return
      end
      subroutine italy(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23328
      return
23328 continue
      if(.not.(lat .lt. 38. .or. lat .gt. 45.))goto 23330
      return
23330 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 -2.0 - 10.7))goto 23332
      return
23332 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 1.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23334
      return
23334 continue
      s(k) = dbeta
      return
      end
      subroutine italyup(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /6271./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23336
      return
23336 continue
      if(.not.(lat .lt. 38. .or. lat .gt. 45.))goto 23338
      return
23338 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 -2.0 - 10.7))goto 23340
      return
23340 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 1.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23342
      return
23342 continue
      s(k) = dbeta
      return
      end
      subroutine italydown(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6171./
      data rdown /5711./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23344
      return
23344 continue
      if(.not.(lat .lt. 38. .or. lat .gt. 45.))goto 23346
      return
23346 continue
      lon0 = 1.25*(56.4-lat) - 4.86
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 -2.0 - 10.7))goto 23348
      return
23348 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 1.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23350
      return
23350 continue
      s(k) = dbeta
      return
      end
      subroutine italy1(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23352
      return
23352 continue
      if(.not.(lat .lt. 44. .or. lat .gt. 46.))goto 23354
      return
23354 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 -2.0 - 10.7))goto 23356
      return
23356 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 1.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23358
      return
23358 continue
      s(k) = dbeta
      return
      end
      subroutine italy2(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23360
      return
23360 continue
      if(.not.(lat .lt. 39. .or. lat .gt. 42.))goto 23362
      return
23362 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 -2.0 - 10.7))goto 23364
      return
23364 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 1.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23366
      return
23366 continue
      s(k) = dbeta
      return
      end
      subroutine tunisia(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6321./
      data rdown /6221./
      data dbeta /+500./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23368
      return
23368 continue
      if(.not.(lat .lt. 24. .or. lat .gt. 37.))goto 23370
      return
23370 continue
      if(.not.(lon .gt. 12 .or. lon .lt. -10))goto 23372
      return
23372 continue
      s(k) = dbeta
      return
      end
      subroutine egitto(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6321./
      data rdown /6221./
      data dbeta /+500./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23374
      return
23374 continue
      if(.not.(lat .lt. 29.5 .or. lat .gt. 32.5))goto 23376
      return
23376 continue
      if(.not.(lon .gt. 31.5 .or. lon .lt. 28.5))goto 23378
      return
23378 continue
      s(k) = dbeta
      return
      end
      subroutine egitto1(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6321./
      data rdown /6221./
      data dbeta /+600./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23380
      return
23380 continue
      if(.not.(lat .lt. 35. .or. lat .gt. 37.))goto 23382
      return
23382 continue
      if(.not.(lon .gt. 29 .or. lon .lt. 27))goto 23384
      return
23384 continue
      s(k) = dbeta
      return
      end
      subroutine sort(n,ra,na)
      dimension ra(n), na(n)
      l=n/2+1
      ir=n
10    continue
      if(.not.(l.gt.1))goto 23386
      l=l-1
      rra=ra(l)
      nna=na(l)
      goto 23387
23386 continue
      rra=ra(ir)
      nna=na(ir)
      ra(ir)=ra(1)
      na(ir)=na(1)
      ir=ir-1
      if(.not.(ir.eq.1))goto 23388
      ra(1)=rra
      na(1)=nna
      return
23388 continue
23387 continue
      i=l
      j=l+l
20    if(.not.(j.le.ir))goto 23390
      if(.not.(j.lt.ir))goto 23392
      if(.not.(ra(j).gt.ra(j+1)))goto 23394
      j=j+1
23394 continue
23392 continue
      if(.not.(rra.gt.ra(j)))goto 23396
      ra(i)=ra(j)
      na(i)=na(j)
      i=j
      j=j+j
      goto 23397
23396 continue
      j=ir+1
23397 continue
      go to 20
23390 continue
      ra(i)=rra
      na(i)=nna
      go to 10
      end
      subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
      dimension wc(10)
      ksteps = int(st/step-0.0001)
      if(.not.(ksteps .lt.0 .or. ksteps .gt. 10))goto 23398
      write(6,*) 'No such smoothing'
      stop
23398 continue
      write(6,*) 'ksteps = ',ksteps
      mazi = 8
      w0 = 1.
      wsum = w0
      do 23400 k = 1,ksteps 
      wc(k) = 8.*cos(0.5*3.1415926535897932*k*step/st)
      wsum = wsum + k*wc(k)
23400 continue
      w0 = w0/wsum
      do 23402 k = 1,ksteps 
      wc(k) = wc(k)/(wsum*mazi)
23402 continue
      write(6,*) stk,st,step,ksteps,mazi
      write(6,*) w0,(wc(k),k=1,ksteps)
      return
      end
      subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
      dimension i(30000),f(30000)
      dimension i8(8),f8(8)
      dimension wc(10)
      logical out
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      np = 0
      do 23404 l = 1,30000 
      i(l) = 0
      f(l) = 0. 
23404 continue
      r0 = rp
      t0 = tp
      f0 = fp
      x0 = xp
      y0 = yp
      z0 = zp
      out = .false.
      if(.not.(x0 .lt. xmin .or. x0 .gt. xmax .or. y0 .lt. ymin .or. y0 
&     .gt. ymax .or. z0 .lt. zmin .or. z0 .gt. zmax))goto 23406
      out = .true.
      return
23406 continue
      r0 = r0 + 90
      do 23408 kdp = 1,4 
      call rtfxyz(0,t0,f0,r0,x0,y0,z0)
      call trilin(x0,y0,z0,n8,i8,f8)
      do 23410 l=1,n8 
      call addif(i8(l),f8(l),w0,np,i,f)
23410 continue
      na = 0
      dcst = 0.
      az = 0.
      do 23412 k = 1,ksteps 
      na = na + mazi
      daz = 2.*3.1415926535897932/na
      az = az + 0.5*daz
      dcst = dcst + step
      wk = wc(k)
      do 23414 ia = 1,na 
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do 23416 l=1,n8 
      call addif(i8(l),f8(l),wk,np,i,f)
23416 continue
23414 continue
23412 continue
      r0 = r0 - 60.
23408 continue
      return
      end
      subroutine trilin(xq,yq,zq,n8,i8,f8)
      dimension i8(8),f8(8)
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      if(.not.(xq .lt. xmin .or. xq .gt. xmax .or. yq .lt. ymin .or. yq 
&     .gt. ymax .or. zq .lt. zmin .or. zq .gt. zmax))goto 23418
      n8 = 0
      return
23418 continue
      n8 = 8
23419 continue
      xdist = (xq - xmin)/dx
      ydist = (ymax - yq)/dy
      zdist = (zmax - zq)/dz
      ixmn = int(xdist) + 1
      ixmx = ixmn + 1
      if(.not.(ixmn .eq. nx))goto 23420
      ixmx = ixmn
      ixmn = ixmx - 1 
23420 continue
      iymn = int(ydist) + 1
      iymx = iymn + 1
      if(.not.(iymn .eq. ny))goto 23422
      iymx = iymn
      iymn = iymx - 1 
23422 continue
      izmn = int(zdist) + 1
      izmx = izmn + 1
      if(.not.(izmn .eq. nz))goto 23424
      izmx = izmn
      izmn = izmx - 1 
23424 continue
      lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn
      i8(1) = lub
      i8(2) = lub + 1
      i8(3) = lub + nx
      i8(4) = i8(3) + 1
      i8(5) = lub + nxy
      i8(6) = i8(5) + 1
      i8(7) = i8(5) + nx
      i8(8) = i8(7) + 1
      x = xdist - (ixmn-1)
      y = (iymx-1) - ydist
      z = (izmx-1) - zdist
      xy = x*y
      xz = x*z
      yz = y*z
      xyz = xy*z
      f8(1) = yz - xyz
      f8(2) = xyz
      f8(3) = z - yz - xz + xyz
      f8(4) = xz - xyz
      f8(5) = y - xy - yz + xyz
      f8(6) = xy - xyz
      f8(7) = 1 - x - y - z + xy + yz + xz - xyz
      f8(8) = x - xy - xz + xyz
      return
      end
      subroutine addif(iin,fin,wt,n,iarr,farr)
      dimension iarr(30000), farr(30000)
      jl = 0
      ju = n + 1
      do 23426 while ((ju-jl) .gt. 1) 
      jm = (ju+jl)/2
      if(.not.(iin .gt. iarr(jm)))goto 23428
      jl = jm
      goto 23429
23428 continue
      ju = jm
23429 continue
23426 continue
      if(.not.(iin .eq. iarr(ju)))goto 23430
      farr(ju) = farr(ju) + wt*fin
      goto 23431
23430 continue
      n = n + 1
      do 23432 j = n,ju+1,-1 
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
23432 continue
      iarr(ju) = iin
      farr(ju) = wt*fin
23431 continue
      return
      end
