      program makeeuc
      character*7 fname
      dimension solution(13e5)
      dimension jy(5),jn(5),apu(5)
      dimension ia(30000),fa(30000)
      dimension spkdp(1),spkla(40),spklo(40)
      dimension spikdp(1),spikla(2),spiklo(2)
      dimension wc(10)
      dimension xnode(13e5),ynode(13e5)
      dimension it(30000),if(30000)
      dimension tt(610000),pp(610000)
      logical out
      real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
      data itypes/2/
      data itypemoho/5/
      data spikdp/200/
      data spikla/-21,-5/
      data spiklo/-47,-63/
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      do 23000 i=1,13e5 
      solution(i) = 0.
23000 continue
      call setgrid(ddd,avdd,distmax)
      write(6,*) nsq,' nodes in 3D model'
      open(1,file='model.shell',status='old')
      rewind(1)
      read(1,*) ntr,nt,imx,dmxd,cold,rmoho
      read(1,*) (tt(i),i=1,ntr)
      read(1,*) (pp(i),i=1,ntr)
      close(1)
      col = cold*1.74533e-2
      call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
      n=0
      j=1
      do 23002 while (jy(j) .lt. itypemoho) 
      n = n+1
      j = j+1
23002 continue
      if(.not.(jy(j) .ne. itypemoho))goto 23004
      write(6,*) 'Sorry, your data do not include Moho'
      write(6,*) 'I will not compute a synthetic model.'
      stop
23004 continue
      apus=apu(j)
      ioff=n
      noff = ioff*nsq
      print*, 'noff=',noff
      ncol = njy*nsq + jmoho*ntr
      write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol
      stk = 80.
      st = stk/6371.
      step = 55./6371.
      call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
      out = .false.
      open(2,file='crust.xyz',status='old')
      rewind 2
29    read(2,*,end=34) on,at,oho
      at = at*1.74533e-2
      on = on*1.74533e-2
      call rotate(0,at,on,t,f)
      call gett(out,col,t,f,ntr,tt,pp,nl,it,ft)
      do 23006 l=1,nl 
      index = noff + it(l)
      solution(index) = (oho - 30.)*1000.
23006 continue
      goto 29
34    continue
      smin = 0
      smax = 0
      do 23008 i=1,ncol 
      smax = max(solution(i),smax)
      smin = min(solution(i),smin)
23008 continue
      write(6,*) 'min,max solution:',smin,smax
      fname = "syn.moho"
      open(1,file=fname,status='new')
      rewind 1
      write(1,*) ncol
      write(1,*) (solution(i),i=1,ncol)
      close(1)
      kdp = 1
      jspk = 0
      dsol = -300.
      end
      subroutine slab1(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23010
      return
23010 continue
      if(.not.(lat .lt. 34. .or. lat .gt. 43.))goto 23012
      return
23012 continue
      lon0 = 0.44*(83.75-lat)
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 2.0 + 10.7))goto 23014
      return
23014 continue
      llon0 = lon0 + (rup-r)*10.7/660.
      rlon0 = llon0 + 2.0
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23016
      return
23016 continue
      s(k) = dbeta
      return
      end
      subroutine slab1neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-300./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23018
      return
23018 continue
      if(.not.(lat .lt. 34. .or. lat .gt. 43.))goto 23020
      return
23020 continue
      lon0 = 0.44*(83.75-lat) + 2.0
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 2.0 + 10.7))goto 23022
      return
23022 continue
      llon0 = lon0 + (rup-r)*10.7/660.
      rlon0 = llon0 + 2.0
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23024
      return
23024 continue
      s(k) = dbeta
      return
      end
      subroutine slab2(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23026
      return
23026 continue
      if(.not.(lat .lt. 36. .or. lat .gt. 40.))goto 23028
      return
23028 continue
      lon0 = 0.75*(lat-17)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 7.7))goto 23030
      return
23030 continue
      llon0 = lon0 - (rup-r)*7.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23032
      return
23032 continue
      s(k) = dbeta
      return
      end
      subroutine slab2neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23034
      return
23034 continue
      if(.not.(lat .lt. 36. .or. lat .gt. 40.))goto 23036
      return
23036 continue
      lon0 = 0.75*(lat-17) - 1.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 1.5 - 7.7))goto 23038
      return
23038 continue
      llon0 = lon0 - (rup-r)*7.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23040
      return
23040 continue
      s(k) = dbeta
      return
      end
      subroutine slab3(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23042
      return
23042 continue
      if(.not.(lat .lt. 40. .or. lat .gt. 45.))goto 23044
      return
23044 continue
      lon0 = 1.25*(56.4-lat)
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 10.7))goto 23046
      return
23046 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23048
      return
23048 continue
      s(k) = dbeta
      return
      end
      subroutine slab3neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lon0
      real lat,lon
      data rup /6371./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23050
      return
23050 continue
      if(.not.(lat .lt. 40. .or. lat .gt. 45.))goto 23052
      return
23052 continue
      lon0 = 1.25*(56.4-lat) - 2.0 - 1.5
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 2.0 - 10.7))goto 23054
      return
23054 continue
      llon0 = lon0 - (rup-r)*10.7/660.
      rlon0 = llon0 - 2.0
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23056
      return
23056 continue
      s(k) = dbeta
      return
      end
      subroutine slab4(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lat0
      real lat,lon
      data rup /6171./
      data rdown /5711./
      data dbeta /+400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23058
      return
23058 continue
      if(.not.(lon .lt. -3. .or. lon .gt. 3.))goto 23060
      return
23060 continue
      lat0 = 37.
      if(.not.(lat .lt. lat0 .or. lat .gt. lat0 + 2.0 + 7.5))goto 23062
      return
23062 continue
      llat0 = lat0 + (rup-r)*7.5/460.
      rlat0 = llat0 + 2.0
      if(.not.(lat .lt. llat0 .or. lat .gt. rlat0))goto 23064
      return
23064 continue
      s(k) = dbeta
      return
      end
      subroutine slab4neg(r,lat,lon,s,k)
      dimension s(13e5)
      real llon0,rlon0,lat0
      real lat,lon
      data rup /6171./
      data rdown /5711./
      data dbeta /-400./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23066
      return
23066 continue
      if(.not.(lon .lt. -3. .or. lon .gt. 3.))goto 23068
      return
23068 continue
      lat0 = 37. + 2.0
      if(.not.(lat .lt. lat0 .or. lat .gt. lat0 + 2.0 + 7.5))goto 23070
      return
23070 continue
      llat0 = lat0 + (rup-r)*7.5/460.
      rlat0 = llat0 + 2.0
      if(.not.(lat .lt. llat0 .or. lat .gt. rlat0))goto 23072
      return
23072 continue
      s(k) = dbeta
      return
      end
      subroutine wedge1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6171./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23074
      return
23074 continue
      if(.not.(lat .lt. 34 .or. lat .gt. 43))goto 23076
      return
23076 continue
      lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 2.0
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 4.))goto 23078
      return
23078 continue
      llon0 = lon0 + (rup-r)*4./257.
      rlon0 = lon0 + 4.
      if(.not.(lon .lt. llon0 .or. lon .gt. rlon0))goto 23080
      return
23080 continue
      s(k) = dbeta
      return
      end
      subroutine wedge2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6163./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23082
      return
23082 continue
      if(.not.(lat .lt. 36 .or. lat .gt. 40))goto 23084
      return
23084 continue
      lon0 = 0.75*(lat-17) - 2.5 - 1.0 - 2.0
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 4.))goto 23086
      return
23086 continue
      llon0 = lon0 - (rup-r)*4./257.
      rlon0 = lon0 - 4.
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23088
      return
23088 continue
      s(k) = dbeta
      return
      end
      subroutine wedge3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6113./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23090
      return
23090 continue
      if(.not.(lat .lt. 40 .or. lat .gt. 45))goto 23092
      return
23092 continue
      lon0 = 1.25*(56.4-lat) - 2.0 - 2.0
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 4.))goto 23094
      return
23094 continue
      llon0 = lon0 - (rup-r)*4./257.
      rlon0 = lon0 - 4.
      if(.not.(lon .gt. llon0 .or. lon .lt. rlon0))goto 23096
      return
23096 continue
      s(k) = dbeta
      return
      end
      subroutine wedge4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6113./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23098
      return
23098 continue
      if(.not.(lat .lt. 44 .or. lat .gt. 48))goto 23100
      return
23100 continue
      lon0 = 1.25*(58.2-lat)
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 8.))goto 23102
      return
23102 continue
      s(k) = dbeta
      return
      end
      subroutine wedge5(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lon0
      data rup /6306./
      data rdown /6171./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23104
      return
23104 continue
      if(.not.(lat .lt. 34 .or. lat .gt. 43))goto 23106
      return
23106 continue
      lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 1.0 + 4.
      if(.not.(lon .lt. lon0 .or. lon .gt. lon0 + 8.))goto 23108
      return
23108 continue
      s(k) = dbeta
      return
      end
      subroutine wedge6(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6306./
      data rdown /6193./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23110
      return
23110 continue
      if(.not.(lat .lt. 38 .or. lat .gt. 44))goto 23112
      return
23112 continue
      lon0 = 1.25*(56.4-lat) - 2.5 - 1.0 - 7.
      if(.not.(lon .gt. lon0 .or. lon .lt. lon0 - 14.))goto 23114
      return
23114 continue
      lat0 = 0.72*lon + 39.8
      if(.not.(lat .gt. lat0))goto 23116
      return
23116 continue
      s(k) = dbeta
      return
      end
      subroutine wedge7(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6306./
      data rdown /6193./
      data dbeta /-250./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23118
      return
23118 continue
      if(.not.(lat .lt. 36 .or. lat .gt. 38))goto 23120
      return
23120 continue
      if(.not.(lon .gt. 9. .or. lon .lt. -2.5))goto 23122
      return
23122 continue
      s(k) = dbeta
      return
      end
      subroutine crust1(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6301./
      data dbetapiu /200./
      data dbetameno /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23124
      return
23124 continue
      if(.not.(lat .gt. 50 .or. lat .lt. 25))goto 23126
      return
23126 continue
      if(.not.(lon .gt. 35 .or. lon .lt. -10))goto 23128
      return
23128 continue
      if(.not.((lat .lt. 50 .and. lat .gt. 45) .or. (lat .lt. 40 .and. 
&     lat .gt. 35) .or. (lat .lt. 30 .and. lat .gt. 25)))goto 23130
      if(.not.((lon .gt. -10 .and. lon .lt. -5) .or. (lon .gt. 0 .and. 
&     lon .lt. 5) .or. (lon .gt. 10 .and. lon .lt. 15) .or. (lon .gt. 
&     20 .and. lon .lt. 25) .or. (lon .gt. 30 .and. lon .lt. 35)))goto 2
&     3132
      s(k) = dbetapiu
      goto 23133
23132 continue
      s(k) = dbetameno
23133 continue
23130 continue
      if(.not.((lat .lt. 45 .and. lat .gt. 40) .or. (lat .lt. 35 .and. 
&     lat .gt. 30)))goto 23134
      if(.not.((lon .gt. -10 .and. lon .lt. -5) .or. (lon .gt. 0 .and. 
&     lon .lt. 5) .or. (lon .gt. 10 .and. lon .lt. 15) .or. (lon .gt. 
&     20 .and. lon .lt. 25) .or. (lon .gt. 30 .and. lon .lt. 35)))goto 2
&     3136
      s(k) = dbetameno
      goto 23137
23136 continue
      s(k) = dbetapiu
23137 continue
23134 continue
      return
      end
      subroutine crust2(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23138
      return
23138 continue
      if(.not.(lat .gt. 45 .or. lat .lt. 38))goto 23140
      return
23140 continue
      if(.not.(lon .gt. 20 .or. lon .lt. 9))goto 23142
      return
23142 continue
      s(k) = dbeta
      return
      end
      subroutine crust3(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23144
      return
23144 continue
      if(.not.(lat .gt. 45 .or. lat .lt. 38))goto 23146
      return
23146 continue
      if(.not.(lon .gt. 28 .or. lon .lt. 21))goto 23148
      return
23148 continue
      s(k) = dbeta
      return
      end
      subroutine crust4(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23150
      return
23150 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23152
      return
23152 continue
      if(.not.(lon .gt. 28 .or. lon .lt. 21))goto 23154
      return
23154 continue
      s(k) = dbeta
      return
      end
      subroutine crust5(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23156
      return
23156 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23158
      return
23158 continue
      if(.not.(lon .gt. 20 .or. lon .lt. 9))goto 23160
      return
23160 continue
      s(k) = dbeta
      return
      end
      subroutine crust6(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon,lat0,lon0
      data rup /6371./
      data rdown /6311./
      data dbeta /-200./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23162
      return
23162 continue
      if(.not.(lat .gt. 37 .or. lat .lt. 30))goto 23164
      return
23164 continue
      if(.not.(lon .gt. 8 .or. lon .lt. 0))goto 23166
      return
23166 continue
      s(k) = dbeta
      return
      end
      subroutine constant(r,lat,lon,s,k)
      dimension s(13e5)
      real lat,lon
      data rup /6571./
      data rdown /5271./
      data dbeta /150./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23168
      return
23168 continue
      if(.not.(lat .lt. 15 .or. lat .gt. 60))goto 23170
      return
23170 continue
      if(.not.(lon .lt. -55 .or. lon .gt. 60.))goto 23172
      return
23172 continue
      s(k) = dbeta
      return
      end
      subroutine sort(n,ra,na)
      dimension ra(n), na(n)
      l=n/2+1
      ir=n
10    continue
      if(.not.(l.gt.1))goto 23174
      l=l-1
      rra=ra(l)
      nna=na(l)
      goto 23175
23174 continue
      rra=ra(ir)
      nna=na(ir)
      ra(ir)=ra(1)
      na(ir)=na(1)
      ir=ir-1
      if(.not.(ir.eq.1))goto 23176
      ra(1)=rra
      na(1)=nna
      return
23176 continue
23175 continue
      i=l
      j=l+l
20    if(.not.(j.le.ir))goto 23178
      if(.not.(j.lt.ir))goto 23180
      if(.not.(ra(j).gt.ra(j+1)))goto 23182
      j=j+1
23182 continue
23180 continue
      if(.not.(rra.gt.ra(j)))goto 23184
      ra(i)=ra(j)
      na(i)=na(j)
      i=j
      j=j+j
      goto 23185
23184 continue
      j=ir+1
23185 continue
      go to 20
23178 continue
      ra(i)=rra
      na(i)=nna
      go to 10
      end
      subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
      dimension wc(10)
      ksteps = int(st/step-0.0001)
      if(.not.(ksteps .lt.0 .or. ksteps .gt. 10))goto 23186
      write(6,*) 'No such smoothing'
      stop
23186 continue
      write(6,*) 'ksteps = ',ksteps
      mazi = 8
      w0 = 1.
      wsum = w0
      do 23188 k = 1,ksteps 
      wc(k) = 8.*cos(0.5*3.1415926535897932*k*step/st)
      wsum = wsum + k*wc(k)
23188 continue
      w0 = w0/wsum
      do 23190 k = 1,ksteps 
      wc(k) = wc(k)/(wsum*mazi)
23190 continue
      write(6,*) stk,st,step,ksteps,mazi
      write(6,*) w0,(wc(k),k=1,ksteps)
      return
      end
      subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
      dimension i(30000),f(30000)
      dimension i8(8),f8(8)
      dimension wc(10)
      logical out
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      np = 0
      do 23192 l = 1,30000 
      i(l) = 0
      f(l) = 0. 
23192 continue
      r0 = rp
      t0 = tp
      f0 = fp
      x0 = xp
      y0 = yp
      z0 = zp
      out = .false.
      if(.not.(x0 .lt. xmin .or. x0 .gt. xmax .or. y0 .lt. ymin .or. y0 
&     .gt. ymax .or. z0 .lt. zmin .or. z0 .gt. zmax))goto 23194
      out = .true.
      return
23194 continue
      r0 = r0 + 90
      do 23196 kdp = 1,4 
      call rtfxyz(0,t0,f0,r0,x0,y0,z0)
      call trilin(x0,y0,z0,n8,i8,f8)
      do 23198 l=1,n8 
      call addif(i8(l),f8(l),w0,np,i,f)
23198 continue
      na = 0
      dcst = 0.
      az = 0.
      do 23200 k = 1,ksteps 
      na = na + mazi
      daz = 2.*3.1415926535897932/na
      az = az + 0.5*daz
      dcst = dcst + step
      wk = wc(k)
      do 23202 ia = 1,na 
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do 23204 l=1,n8 
      call addif(i8(l),f8(l),wk,np,i,f)
23204 continue
23202 continue
23200 continue
      r0 = r0 - 60.
23196 continue
      return
      end
      subroutine trilin(xq,yq,zq,n8,i8,f8)
      dimension i8(8),f8(8)
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      if(.not.(xq .lt. xmin .or. xq .gt. xmax .or. yq .lt. ymin .or. yq 
&     .gt. ymax .or. zq .lt. zmin .or. zq .gt. zmax))goto 23206
      n8 = 0
      return
23206 continue
      n8 = 8
23207 continue
      xdist = (xq - xmin)/dx
      ydist = (ymax - yq)/dy
      zdist = (zmax - zq)/dz
      ixmn = int(xdist) + 1
      ixmx = ixmn + 1
      if(.not.(ixmn .eq. nx))goto 23208
      ixmx = ixmn
      ixmn = ixmx - 1 
23208 continue
      iymn = int(ydist) + 1
      iymx = iymn + 1
      if(.not.(iymn .eq. ny))goto 23210
      iymx = iymn
      iymn = iymx - 1 
23210 continue
      izmn = int(zdist) + 1
      izmx = izmn + 1
      if(.not.(izmn .eq. nz))goto 23212
      izmx = izmn
      izmn = izmx - 1 
23212 continue
      lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn
      i8(1) = lub
      i8(2) = lub + 1
      i8(3) = lub + nx
      i8(4) = i8(3) + 1
      i8(5) = lub + nxy
      i8(6) = i8(5) + 1
      i8(7) = i8(5) + nx
      i8(8) = i8(7) + 1
      x = xdist - (ixmn-1)
      y = (iymx-1) - ydist
      z = (izmx-1) - zdist
      xy = x*y
      xz = x*z
      yz = y*z
      xyz = xy*z
      f8(1) = yz - xyz
      f8(2) = xyz
      f8(3) = z - yz - xz + xyz
      f8(4) = xz - xyz
      f8(5) = y - xy - yz + xyz
      f8(6) = xy - xyz
      f8(7) = 1 - x - y - z + xy + yz + xz - xyz
      f8(8) = x - xy - xz + xyz
      return
      end
      subroutine addif(iin,fin,wt,n,iarr,farr)
      dimension iarr(30000), farr(30000)
      jl = 0
      ju = n + 1
      do 23214 while ((ju-jl) .gt. 1) 
      jm = (ju+jl)/2
      if(.not.(iin .gt. iarr(jm)))goto 23216
      jl = jm
      goto 23217
23216 continue
      ju = jm
23217 continue
23214 continue
      if(.not.(iin .eq. iarr(ju)))goto 23218
      farr(ju) = farr(ju) + wt*fin
      goto 23219
23218 continue
      n = n + 1
      do 23220 j = n,ju+1,-1 
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
23220 continue
      iarr(ju) = iin
      farr(ju) = wt*fin
23219 continue
      return
      end
