subroutine rtfxyz(mode,teta,fi,r,x,y,z)
include defines
# teta = latitude, fi = longitude, relative to new (rotated)
# northpole and equator. r = distance from Earth's center (0,0,0).
# if mode=0 r,teta,fi --> x,y,z
# if mode=1 x,y,z --> r,teta,fi

if (mode == 0) {
   ct = cos(teta)
   x = r*ct*cos(fi)
   y = r*ct*sin(fi)
   z = r*sin(teta)
} else if (mode == 1) {
   x2 = x*x
   y2 = y*y
   z2 = z*z
   r = sqrt(x2 + y2 + z2)
   fi = atan2(y,x)
   teta = atan2(z,sqrt(x2 + y2))
} else {
   x=0;y=0;z=0
   r=0;teta=0;fi=0
   mode=-1
}

return
end
