subroutine scwapu(n,x)
include defines
dimension x(n)
dimension jy(nrfpr),apu(nrfpr),jn(nrfpr)

call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
open(2,file='model.cube',status='old')
rewind 2
read(2,*) ola,olo,oazi,nz,ny,nx
close(2)
nsq = nz*ny*nx
nn = njy*nsq 
if (jmoho==1) {
   open(2,file='model.shell',status='old')
   rewind 2
   read(2,*) ntr
   close(2)
} else {
   ntr = 0
}
nn = nn + jmoho*ntr
if (nn != n) {
   write(6,*) 'ERROR: nn (from settings) = ',nn,' while n (from inv) = ',n
   write(6,*) 'solution NOT written'
   stop
}

do j=1,njy {
   ioff = (j-1)*nsq
   do i = ioff+1,ioff+nsq {
      x(i) = apu(j)*x(i)
   }
}
ioff = njy*nsq
do i = ioff+1,ioff+ntr {
   x(i) = apu5*x(i)
}
write(6,*) 'solution rescaled with a priori uncertainties'

return
end
