subroutine setsmooth(stk,st,step,ksteps,mazi,w0,wc)
include sdefines
dimension wc(kmax)

ksteps = int(st/step-0.0001)
write(6,*) 'ksteps = ',ksteps
if (ksteps <0 | ksteps > kmax) {
   write(6,*) 'No such smoothing' 
   stop
}
mazi = 8
w0 = 1.
wsum = w0
do k = 1,ksteps {
   wc(k) = 8.*(1. - k*step/st)
   wsum = wsum + k*wc(k)
}
w0 = w0/wsum
do k = 1,ksteps {
   wc(k) = wc(k)/(wsum*mazi)
}
write(6,*) stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
open(2,file='smooth')
rewind 2
write(2,*) stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
close(2)   

return
end
