subroutine settria(ddd,dmx,col,rmoho,ntr,tt,pp)
include defines

dimension tt(mxtr),pp(mxtr)
logical ex
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

inquire(file='model.shell',exist=ex)
open(2,file='model.shell')
if (ex) {
   read(2,*) ntr,nt,imx,dmxd,cold,rmoho
   read(2,*) (tt(k),k=1,ntr)
   read(2,*) (pp(k),k=1,ntr) 
   dmx = dmxd*p
   col = cold*p
   write(6,*) 'model.shell already present, NOT creating it anew!!'
} else {
   # estimate of spacing between grid points, the real average (ddel
   # in tricoor) will be somewhat higher.
   # find the min colatitude necessary to contain the specified cube model:
   xy1 = sqrt(xmin*xmin + ymin*ymin)
   xy2 = sqrt(xmin*xmin + ymax*ymax)
   xy3 = sqrt(xmax*xmax + ymax*ymax)
   xy4 = sqrt(xmax*xmax + ymin*ymin)
   scol1 = max(xy1,xy2,xy3,xy4); scol1 = scol1/radius 
   if (scol1 > 1.) scol1 = 1. 
   scol2 = zmin/radius; if (scol2 > 1.) scol2 = 1.
   if (zmin >= 0) {
      col1 = asin(scol1)
      col2 = acos(scol2) 
      col = min(col1,col2) }
   else { col = acos(scol2) }
   cold = col/p
   write(6,*) "colatitude = ",cold," degrees"
   write(6,*) "so the min latitude = ",90-cold," degrees"
   write(6,*) "setting up model.shell..."
   do i=1,mxtr {
      tt(i) = 0.
      pp(i) = 0.
   }
   call tri(ddd,dmx,col,nt,imx,ntr,tt,pp)
   write(6,*) 'area has ',ntr,' nodes'
   write(6,*) ''
   dmxd = dmx/p
   write(2,*) ntr,nt,imx,dmxd,cold,rmoho
   write(2,*) (tt(k),k=1,ntr)
   write(2,*) (pp(k),k=1,ntr) 
}
close(2) 

return
end
